
//  namespace
//  =========
    window.__readable_by_evernote__blank = {};


//  import
//  ======

    (function ($B) {
        
        //  escape html
        //  ===========
            var _escape_html = function (_string)
            {
                var _replace = { "&": "amp", '"': "quot", "<": "lt", ">": "gt" };
                return _string.replace(/[&"<>]/g, function (_match) { var _r = _replace[_match]; return (_r ? ("&" + _r + ";") : _match); });
            };
            
        
        //  escape html
        //  ===========
            var _unescape_html = function (_string)
            {
                var _replace = { "amp": "&", "quot": '"', "lt": "<", "gt": ">" };
                return _string.replace(/[&](amp|quot|lt|gt)[;]/g, function (_match, _match_key) { var _r = _replace[_match_key]; return (_r ? _r : _match); });
            };
        
        
        //  encode
        //  ======
            var _encode = function (_string)
            {
                if (_string == '') { return 'none'; }
                var _replace = { "!": "%21", "'": "%27", "(": "%28", ")": "%29", "*": "%2A" };
                return _string.replace(/[!'()*]/g, function (_match) { return _replace[_match]; });
            };
        
            
        //  decode
        //  ======
            var _decode = function (_string)
            {
                if (_string == 'none') { return ''; }
                return decodeURIComponent(_string);
            };
        
        /* =============== */
        $B.escape_html = _escape_html;
        $B.unescape_html = _unescape_html;
    })(window.__readable_by_evernote__blank);

    (function ($B) {
        
        //  translations
        //  ============
            var _translations_in_page = {
                'menu__close__tooltip':                         'Hide the overlay.',
                'menu__clip_to_evernote__tooltip':              'Clip to Evernote.',
                'menu__highlight_to_evernote__tooltip':         'Highlight.',
                'menu__print__tooltip':                         'Print.',
                'menu__settings__tooltip':                      'Show Themes.',
                'menu__fitts__tooltip':                         'Hide the overlay.',
                'menu__speak__tooltip':                         'Text To Speech',
                'menu__speak__play__tooltip':                   'Play',
                'menu__speak__pause__tooltip':                  'Pause',
                'menu__speak__forward__tooltip':                'Go Forwards',
                'menu__speak__rewind__tooltip':                 'Go Backwards',
                
                /* === */
                
                'rtl__main__label':                             'Text direction?',
                'rtl__ltr__label':                              'Left-to-right',
                'rtl__rtl__label':                              'Right-to-left',
        
                /* === */
                
                'blank_error__heading':                         'Tips for using Evernote Clearly',
                'blank_error__body':                            'Clearly is currently designed to work on article pages. An article page is any page that contains one large block of text -- like, for example, a newspaper article or blog post.',
        
                /* === */
                
                'related_notes__title':                         'Related Notes',
                'related_notes__disable_short':                 'Disable?',
                'related_notes__disable_long':                  'Do you want to disable Related Notes?',
        
                /* === */
        
                'filing_info__title_normal':                    'Filed in:',
                'filing_info__title_smart':                     'Smart Filed in:',
                'filing_info__default_notebook':                'Default',
                'filing_info__view':                            'View',
                'filing_info__edit':                            'Edit',
                'filing_info__sentence':                        'Clipped into the [=notebook] notebook, and tagged with [=tags].',
                'filing_info__sentence_no_tags':                'Clipped into the [=notebook] notebook.',
                'filing_info__sentence_and':                    'and',
                'filing_info__sentence_other_tags':             'other tags',
        
                /* === */
                
                'evernote_clipping':                            'Clipping...',
                'evernote_clipping_failed':                     'Clipping failed.',
                
                'evernote_login__request':                      'To sign in to Evernote, please click the Clearly icon in Chrome\'s toolbar.',
                
                'evernote_login__heading':                      'Sign in to Evernote',
                'evernote_login__spinner':                      'Signing in to Evernote',
                'evernote_login__create_account':               'Create an account',
                'evernote_login__button_do__label':             'Sign in',
                'evernote_login__button_cancel__label':         'Cancel',
                
                'evernote_login__username__label':              'Evernote Username or Email Address',
                'evernote_login__password__label':              'Password',
                'evernote_login__rememberMe__label':            'Remember me',
        
                'evernote_login__username__error__required':    'Username is required.',
                'evernote_login__username__error__length':      'Username must be between 1 and 64 characters long.',
                'evernote_login__username__error__format':      'Username contains bad characters.',
                'evernote_login__username__error__invalid':     'Not a valid, active user.',
                
                'evernote_login__password__error__required':    'Password is required.',
                'evernote_login__password__error__length':      'Password must be between 6 and 64 characters long.',
                'evernote_login__password__error__format':      'Password contains bad characters.',
                'evernote_login__password__error__invalid':     'Username and password do not match existing user.',
                'evernote_login__password__error__timeout':     'Login session timed-out. Please try again.',
        
                'evernote_login__password__error__reset':       'Your password has expired. Please reset it now.',
                'evernote_login__general__error':               'Authentication failed.',
        
                'evernote_two_factor__message__sms':            'We sent a text message with a verification code to',
                'evernote_two_factor__message__google':         'Enter the verification code displayed in your Google Authenticator app.',
        
                'evernote_two_factor__code__label':             'Verification code',
                'evernote_two_factor__code__error__required':   'Verification code is required.',
                'evernote_two_factor__code__error__length':     'Verification code should be at least 6 characters long.',
                'evernote_two_factor__code__error__format':     'Verification code should be only numbers.',
                'evernote_two_factor__code__error__invalid':    'Verification code is incorrect.',
                
                'evernote_two_factor__button_do__label':        'Verify',
                'evernote_two_factor__button_help__label':      'I need help getting a verification code',
        
                /* === */
        
                'settings__theme__1__not_translated':           'Newsprint',
                'settings__theme__2__not_translated':           'Notable',
                'settings__theme__3__not_translated':           'Night Owl',
                
                'settings__theme__1':                           'Newsprint',
                'settings__theme__2':                           'Notable',
                'settings__theme__3':                           'Night Owl',
                'settings__theme__custom':                      'Custom',
                
                'settings__fontSize__small':                    'small',
                'settings__fontSize__medium':                   'medium',
                'settings__fontSize__large':                    'large',
                
                /* === */
                
                'features__title__new':                         'You have a new version of Evernote Clearly!',
                'features__title__all':                         'Welcome to the new Evernote Clearly',
        
                'features__speech__title':                      'Text To Speech',
                'features__speech__text':                       'Sit back and let Clearly read blog posts, articles, and web pages to you thanks to the new Text To Speech feature, available exclusively for Evernote Premium subscribers.',
                'features__speech__text__powered':              'Evernote Clearly is powered by [=service].',
                'features__speech__text__requires':             'Requires [=product].',
                'features__speech__text__available':            'Text To Speech in 21 languages:',
                'features__speech__text__available_languages':  'English, Japanese, Spanish, French, German, Chinese, Korean, Arabic, Czech, Danish, Dutch, Finnish, Greek, Hungarian, Italian, Norwegian, Polish, Portuguese, Russian, Swedish and Turkish.',
                'features__speech__text__try':                  'Try Text To Speech',
                'features__speech__text__upgrade':              'Upgrade to Evernote Premium',
                'features__speech__text__language':             'Language not supported',
                'features__speech__text__play':                 'Play using this language',
                'features__speech__text__cancel':               'Cancel',
                'features__speech__no_language_title':          'Language not supported',
                'features__speech__no_language_explanation':    'Evernote Clearly was not able to determine the language of this article. If you recognize the language, select it below and we\'ll play it.',
                
                'features__clipping__title':                    'Clip to Evernote',
                'features__clipping__text':                     'Save what you\'re reading to your Evernote account with one click. Access clips from any device, anytime in Evernote.',
        
                'features__highlighting__title':                'Highlighting',
                'features__highlighting__text':                 'Highlight text you want to remember & quickly find it in your Evernote account. Highlighting changes you make in Clearly will be updated in your Evernote account automatically.',
        
                'features__related_notes__title':               'Related Notes',
                'features__related_notes__text':                'Magically rediscover notes from your Evernote account that are related to the page you are viewing. Related Notes are displayed at the bottom of the article or on the right side if space permits.',
        
                'features__smart_filing__title':                'Smart Filing',
                'features__smart_filing__text':                 'Automatically assign tags to your Web clips and saves them to the appropriate notebook, so you don\'t have to.',
                
                'features__eula_notice':                        'By using Clearly, you agree to our [=eula].',
                'features__close2':                             'Close',
        
                /* === */
                
                'misc__page':    'page'
            };    
        
        /* =============== */
        $B.translation__items = _translations_in_page;
    })(window.__readable_by_evernote__blank);


//  run
//  ===
    (function ($B) {
    
        //  translated strings may have &stuff; in them
    
        document.title = $B.escape_html($B.unescape_html($B.translation__items['blank_error__heading']));
        document.getElementById('tips__heading').innerHTML = $B.escape_html($B.unescape_html($B.translation__items['blank_error__heading']));
        document.getElementById('tips__body').innerHTML = $B.escape_html($B.unescape_html($B.translation__items['blank_error__body']));
    
    })(window.__readable_by_evernote__blank);
