
//  import target-specific stuff
//  ============================
    (function ($R) {
    
        
        //  storage init
        //  ============
        
            $R.storage__prefs_service = false;
            $R.storage__prefs_branch = false;
        
            $R.storage__init_if_needed = function ()
            {
                //  already initialized
                if ($R.storage__prefs_service && $R.storage__prefs_branch) { return false; }
        
                //  init
                $R.storage__prefs_service = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
                $R.storage__prefs_branch = $R.storage__prefs_service.getBranch("extensions.readable-by-evernote.");
        
                return true;
            };
        
        
        //  storage
        //  =======
        
            $R.storage__get = function (_key)
            {
                $R.storage__init_if_needed();
                try { return $R.storage__prefs_branch.getCharPref(_key); } catch (_e) { return ''; }
            };
        
            $R.storage__set = function (_key, _value)
            {
                $R.storage__init_if_needed();
                try { $R.storage__prefs_branch.setCharPref(_key, _value); } catch (_e) { }
            };
        
            $R.storage__set_more = function (_o)
            {
                $R.storage__init_if_needed();
                for (var _x in _o) { try { $R.storage__prefs_branch.setCharPref(_x, _o[_x]); } catch (_e) { } }
            };
        
        
        //  init
        //  ====
        
            $R.credentials__login_service = false;
            $R.credentials__login_service__url = 'chrome://readable-by-evernote';
            $R.credentials__login_service__label = 'Evernote Login';
        
            $R.credentials__init_if_needed = function ()
            {
                //  already initialized
                if ($R.credentials__login_service) { return false; }
        
                //  init
                $R.credentials__login_service = Components.classes["@mozilla.org/login-manager;1"].getService(Components.interfaces.nsILoginManager);
        
                //  return
                return true;
            };
        
        
        //  get
        //  ===
            $R.credentials__get = function ()
            {
                //  init?
                $R.credentials__init_if_needed();
                
                //  vars
                var _username = $R.storage__get('storedEvernoteUsername'),
                    _server = $R.storage__get('storedEvernoteServer'),
                    _xAuthToken = '',
                    _logins = $R.credentials__login_service.findLogins({}, $R.credentials__login_service__url, '', $R.credentials__login_service__label);
        
                //  find login
                for (var i=0, _i=_logins.length; i<_i; i++) { if (_logins[i].username == _username) { _xAuthToken = _logins[i].password; break; } }
                    
                //  fail
                if ((_username > '') && (_xAuthToken > '')) {}else { return false; }
                    
                //  result
                var _r = {};
                    _r.username = _username;
                    _r.xAuthToken = _xAuthToken;
                    _r.server = ((_server == 'main' || _server == 'china') ? _server : 'none');
                    
                return _r;
            };
        
        
        //  set
        //  ===
            $R.credentials__set = function (_o)
            {
                //  init?
                $R.credentials__init_if_needed();
            
                //  fail
                if ((_o['username'] > '') && (_o['xAuthToken'] > '')) {}else { return false; }
            
                var _login_info__class = new Components.Constructor("@mozilla.org/login-manager/loginInfo;1", Components.interfaces.nsILoginInfo, "init"), 
                    _login_info = new _login_info__class($R.credentials__login_service__url, null, $R.credentials__login_service__label, _o.username, _o.xAuthToken, '', ''),
                    _logins = $R.credentials__login_service.findLogins({}, $R.credentials__login_service__url, '', $R.credentials__login_service__label);
                
                //  set simple
                $R.storage__set('storedEvernoteServer', __readable_by_evernote.$bootstrap.server);
                $R.storage__set('storedEvernoteUsername', _o.username);
                
                //  remove all logins
                try { for (var i=0, _i=_logins.length; i<_i; i++) { if (_logins[i].username == _o.username) { $R.credentials__login_service.removeLogin(_logins[i]); break; } } }
                catch (e) { }
                
                //  add new login
                try { $R.credentials__login_service.addLogin(_login_info); }
                catch (e) { }
                
                return true;
            };
        
        
        //  forget
        //  ======
            $R.credentials__forget = function ()
            {
                //  init?
                $R.credentials__init_if_needed();
        
                //  remove simple
                $R.storage__set_more({
                    'storedEvernoteUsername': '',
                    'storedEvernoteServer': '',
                    'storedEvernoteLogoutOnNextAction' : 'yes'
                });
                
                //  get logins
                var _logins = $R.credentials__login_service.findLogins({}, $R.credentials__login_service__url, '', $R.credentials__login_service__label);
                
                //  remove logins
                try { for (var i=0, _i=_logins.length; i<_i; i++) { if (_logins[i].username == _o.username) { $R.credentials__login_service.removeLogin(_logins[i]); break; } } }
                catch (e) { }
            };
        
        
        //  translation
        //  =========== 
            $R.translation__get_item = function (_key)
            {
                try {
                    var _s = document.getElementById('readable_by_evernote__string_bundle__inside'),
                        _ss = _s.getString('inside__'+_key);
                        
                    return (_ss > '' ? _ss : '');
                }
                catch (e) { }
                
                return '';
            };
        
        
        //  open url
        //  ========
            $R.open_url_in_new_tab = function (_url)
            {
                gBrowser.selectedTab = gBrowser.addTab(_url);
            };
        
        
        //  toolbar button
        //  ==============
            /** 
             * https://developer.mozilla.org/en/Code_snippets/Toolbar#Adding_button_by_default
             * + the old toolbar-button-init.js in the Firefox Evernote Cliper
             * + some meddling
             */  
             
            $R.putButtonInToolbar = function (_toolbarId, _buttonId)
            {
                //  already exists
                if (document.getElementById(_buttonId)) { return; }
        
                //  toolbar
                var _toolbar = document.getElementById(_toolbarId);  
                if (_toolbar) {}else { return; }
        
                //  insert
                var _set = _toolbar.getAttribute('currentset');
                    _set = (_set > '' ? _set : _toolbar.getAttribute('defaultset'));
                    _set += ',' + _buttonId;
                
                //  add
                _toolbar.insertItem(_buttonId, null, null, false);
                _toolbar.setAttribute('currentset', _set);
                _toolbar.currentset = _set;
            
                //  persist
                try { BrowserToolboxCustomizeDone(true); } catch (e) { }
                document.persist(_toolbarId, 'currentset');
            };
        
    
    })(window.__readable_by_evernote);


//  ==========================================================================================================================


//  import _js_anywhere/
//  ====================
    (function ($R) {
    
        (function () {
            
            //  valid url
            //  =========
                var _valid_url = function (_url)
                {
                    //  not string
                    if (_url.indexOf) {}else { return false; }
                    
                    //  look at protocol
                    switch (true)
                    {
                        case (_url.indexOf('http://') === 0):
                        case (_url.indexOf('https://') === 0):
                        case (_url.indexOf('ftp://') === 0):
                        case (_url.indexOf('file://') === 0):
                            return true;
                            break;
                        
                        default:
                            return false;
                            break;
                    }
            
                    return false;
                };
            
            /* =============== */
            $R.valid_url = _valid_url;
        })();

        (function () {
            
            //  escape html
            //  ===========
                var _escape_html = function (_string)
                {
                    var _replace = { "&": "amp", '"': "quot", "<": "lt", ">": "gt" };
                    return _string.replace(/[&"<>]/g, function (_match) { var _r = _replace[_match]; return (_r ? ("&" + _r + ";") : _match); });
                };
                
            
            //  escape html
            //  ===========
                var _unescape_html = function (_string)
                {
                    var _replace = { "amp": "&", "quot": '"', "lt": "<", "gt": ">" };
                    return _string.replace(/[&](amp|quot|lt|gt)[;]/g, function (_match, _match_key) { var _r = _replace[_match_key]; return (_r ? _r : _match); });
                };
            
            
            //  encode
            //  ======
                var _encode = function (_string)
                {
                    if (_string == '') { return 'none'; }
                    var _replace = { "!": "%21", "'": "%27", "(": "%28", ")": "%29", "*": "%2A" };
                    return _string.replace(/[!'()*]/g, function (_match) { return _replace[_match]; });
                };
            
                
            //  decode
            //  ======
                var _decode = function (_string)
                {
                    if (_string == 'none') { return ''; }
                    return decodeURIComponent(_string);
                };
            
            /* =============== */
            $R.escape_html =    _escape_html;
            $R.unescape_html =  _unescape_html;
            $R.encode =         _encode;
            $R.decode =         _decode;
        })();

        (function () {
            
            //  options
            //  =======
                var _default_options = {
                    'text_font':            '"PT Serif"',
                    'text_font_header':     '"PT Serif"',
                    'text_font_monospace':  'Inconsolata',
                    'text_size':            '16px',
                    'text_line_height':     '1.5em',
                    'box_width':            '36em',
                    'color_background':     '#f3f2ee',
                    'color_text':           '#1f0909',
                    'color_links':          '#065588',
                    'text_align':           'normal',
                    'base':                 'theme-1',
                    'footnote_links':       'on_print',
                    'large_graphics':       'do_nothing',
                    'custom_css':           ''
                };
            
            
            //  vars
            //  ====
                var _default_vars = {
                    'theme':                        'theme-1',                          /* theme-1, theme-2, theme-3, custom */
                
                    'keys_activation':              'Control + Alt + Right Arrow',
                    'keys_clip':                    'Control + Alt + Up Arrow',
                    'keys_highlight':               'Control + Alt + H',
                    'keys_speech':                  'Control + Alt + S',
            
                    'clip_tag':                     '',
                    'clip_notebook':                '',
                    'clip_notebook_guid':           '',
                
                    'related_notes':                'enabled',                          /* enabled, just_at_bottom, disabled */
                    'smart_filing':                 'enabled',                          /* enabled, just_notebooks, just_tags, disabled */
                    'smart_filing_for_business':    'disabled',                         /* enabled, disabled */
            
                    'speech_speed':                 'normal',                           /* slowest, slow, slower, normal, faster, fast, fastest */
                    'speech_gender':                'default',                          /* default, female, male */
                
                    'open_notes_in':                'web',                              /* web, desktop */
                
                    'custom_theme_options':         ''                                  /* the custom theme options get serialized into this */
                };
            
                //  mac-specific keyboard shortcuts
                if ((window) && (window.navigator) && (window.navigator.userAgent) && (window.navigator.userAgent.indexOf) && (window.navigator.userAgent.indexOf('Mac OS') > -1))
                {
                    _default_vars['keys_activation'] = 'Control + Command + Right Arrow';
                    _default_vars['keys_clip'] =       'Control + Command + Up Arrow';
                    _default_vars['keys_highlight'] =  'Control + Command + H';
                    _default_vars['keys_speech'] =     'Control + Command + S';
                }
            
            
            //  sizes
            //  =====
                var _the_sizes = {
                    'small':    { 'theme-1': '12px',    'theme-2': '12px',  'theme-3': '12px',  'custom':  '12px' },
                    'medium':   { 'theme-1': '16px',    'theme-2': '16px',  'theme-3': '16px',  'custom':  '16px' },
                    'large':    { 'theme-1': '20px',    'theme-2': '20px',  'theme-3': '20px',  'custom':  '20px' }
                };
            
            
            //  themes
            //  ======
                var _the_themes = {
                    'theme-1': {
                        'text_font':              '"PT Serif"',
                        'text_font_header':       '"PT Serif"',
                        'text_font_monospace':    'Inconsolata',
                        'text_size':              '16px',
                        'text_line_height':       '1.5em',
                        'box_width':              '36em',
                        'color_background':       '#f3f2ee',
                        'color_text':             '#1f0909',
                        'color_links':            '#065588',
                        'text_align':             'normal',
                        'base':                   'theme-1',
                        'footnote_links':         'on_print',
                        'large_graphics':         'do_nothing',
                        'custom_css':             ''
                    },
                    
                    'theme-2': {
                        'text_font':              'Helvetica, Arial',
                        'text_font_header':       'Helvetica, Arial',
                        'text_font_monospace':    '"Droid Sans Mono"',
                        'text_size':              '14px',
                        'text_line_height':       '1.5em',
                        'box_width':              '42em',
                        'color_background':       '#fff',
                        'color_text':             '#333',
                        'color_links':            '#090',
                        'text_align':             'normal',
                        'base':                   'theme-2',
                        'footnote_links':         'on_print',
                        'large_graphics':         'do_nothing',
                        'custom_css':             ''
                    },
                    
                    'theme-3': {
                        'text_font':              '"PT Serif"',
                        'text_font_header':       '"PT Serif"',
                        'text_font_monospace':    'Inconsolata',
                        'text_size':              '16px',
                        'text_line_height':       '1.5em',
                        'box_width':              '36em',
                        'color_background':       '#2d2d2d',
                        'color_text':             '#e3e3e3',
                        'color_links':            '#e3e3e3',
                        'text_align':             'normal',
                        'base':                   'theme-3',
                        'footnote_links':         'on_print',
                        'large_graphics':         'do_nothing',
                        'custom_css':             ''
                    }
                };
            
            /* =============== */
            $R.default_options =        _default_options;
            $R.default_vars =           _default_vars;
            $R.the_sizes =              _the_sizes;
            $R.the_themes =             _the_themes;
        })();

        (function () {
            
            //  Used to show/not-show the dialog box telling people about new stuff in Clearly.
            //  Options:
            //      "the curent version number"
            //      "nope" -- usually this is what this var's value should be.
            
            var _first_show_identifier = '1401864732';
                _first_show_identifier = 'nope';
            
            /* =============== */
            $R.first_show_identifier =  _first_show_identifier;
        })();
        
        (function () {
            
            //  get browser
            //  ===========
                var _from_user_agent__get_browser = function (_user_agent)
                {
                    /*  possible values:
                        ================   
                        desktop:    firefox, safari, chrome, internet_explorer, opera
                        ios:        iphone, ipad
                        mobile:     android, dolphin, firefox_mobile, chrome_mobile, windows_phone
                        other:      unknown
                    */    
            
            
                    //  normalize
                    //  =========
                        _user_agent = _user_agent.toLowerCase();
            
            
                    //  partial detection -- old jQuery code
                    //  =================
                        var _jb = (function ()
                        {
                            var ua = _user_agent,
                                rwebkit = /(webkit)[ \/]([\w.]+)/,
                                ropera = /(opera)(?:.*version)?[ \/]([\w.]+)/,
                                rmsie = /(msie) ([\w.]+)/,
                                rmozilla = /(mozilla)(?:.*? rv:([\w.]+))?/,
                                match = rwebkit.exec( ua ) ||
                                        ropera.exec( ua ) ||
                                        rmsie.exec( ua ) ||
                                        ua.indexOf("compatible") < 0 && rmozilla.exec( ua ) ||
                                        [];
            
                            return { 
                                'browser': match[1] || "", 
                                'version': match[2] || "0" 
                            };            
                        })();
                        
            
                    //  full detection
                    //  ==============
                        var _the_browser = (function ()
                        {
                            var _ua = _user_agent;
                
                            if ((_ua.indexOf('windows phone') > -1))                            { return 'windows_phone'; }
            
                            if ((_ua.indexOf('chrome') > -1) && (_ua.indexOf('android') > -1))  { return 'chrome_mobile'; }
                            if ((_ua.indexOf('firefox') > -1) && (_ua.indexOf('fennec') > -1))  { return 'firefox_mobile'; }
                            if ((_ua.indexOf('dolfin') > -1) || (_ua.indexOf('dolphin') > -1))  { return 'dolphin'; }
                            if ((_ua.indexOf('android') > -1))                                  { return 'android'; }
            
                            if ((_ua.indexOf('ipad') > -1))                                     { return 'ipad'; }
                            if ((_ua.indexOf('iphone') > -1))                                   { return 'iphone'; }
                
                            if ((_jb.browser.opera))                                            { return 'opera'; }
                            if ((_jb.browser.msie))                                             { return 'internet_explorer'; }
                            if ((_jb.browser.webkit) && (_ua.indexOf('chrome') > -1))           { return 'chrome'; }
                            if ((_jb.browser.webkit) && (_ua.indexOf('safari') > -1))           { return 'safari'; }
                            if ((_jb.browser.mozilla))                                          { return 'firefox'; }
                    
                            return 'unknown';
                        })();
                        
                
                    //  return
                    //  ======
                        return _the_browser;       
                };
            
            
            //  get os -- nicely formatted
            //  ======
                var _from_user_agent__get_os = function (_user_agent)
                {
                    var ua = _user_agent.toLowerCase();
                    switch (true)
                    {
                        case (/linux/i.test(ua)):
                            return 'Linux';
                    
                        case (/macintosh/i.test(ua)):
                            var _m = ua.match(/(Mac OS [^\)]+?)\)/i);
                            // if (_m && _m[1]) { return _m[1].replace(/_/g, '.'); }
                            return 'Mac OS';
                        
                        case (/windows/i.test(ua)):
                            var _m = ua.match(/Windows NT ([0-9.]+)/i);
                            var _windows_variants = { 
                                "3.1":  "Windows NT 3.1",
                                "3.5":  "Windows NT 3.5",
                                "3.51": "Windows NT 3.51",
                                "4.0":  "Windows NT 4.0",
                                "5.0":  "Windows 2000",
                                "5.1":  "Windows XP",
                                "5.2":  "Windows XP",
                                "6.0":  "Windows Vista",
                                "6.1":  "Windows 7",
                                "6.2":  "Windows 8"
                            };
                            
                            //  versioned
                            if (_m && _m[1] && _windows_variants[_m[1]]) { return _windows_variants[_m[1]]; }
                            
                            //  default
                            return 'Windows';
                    }
                
                    return 'Unknown OS';
                };
            
            /* =============== */
            $R.from_user_agent__get_browser = _from_user_agent__get_browser;
            $R.from_user_agent__get_os = _from_user_agent__get_os;
        })();
        
        (function () {
            
            //  translations
            //  ============
                var _translations_in_page = {
                    'menu__close__tooltip':                         'Hide the overlay.',
                    'menu__clip_to_evernote__tooltip':              'Clip to Evernote.',
                    'menu__highlight_to_evernote__tooltip':         'Highlight.',
                    'menu__print__tooltip':                         'Print.',
                    'menu__settings__tooltip':                      'Show Themes.',
                    'menu__fitts__tooltip':                         'Hide the overlay.',
                    'menu__speak__tooltip':                         'Text To Speech',
                    'menu__speak__play__tooltip':                   'Play',
                    'menu__speak__pause__tooltip':                  'Pause',
                    'menu__speak__forward__tooltip':                'Go Forwards',
                    'menu__speak__rewind__tooltip':                 'Go Backwards',
                    
                    /* === */
                    
                    'rtl__main__label':                             'Text direction?',
                    'rtl__ltr__label':                              'Left-to-right',
                    'rtl__rtl__label':                              'Right-to-left',
            
                    /* === */
                    
                    'blank_error__heading':                         'Tips for using Evernote Clearly',
                    'blank_error__body':                            'Clearly is currently designed to work on article pages. An article page is any page that contains one large block of text -- like, for example, a newspaper article or blog post.',
            
                    /* === */
                    
                    'related_notes__title':                         'Related Notes',
                    'related_notes__disable_short':                 'Disable?',
                    'related_notes__disable_long':                  'Do you want to disable Related Notes?',
            
                    /* === */
            
                    'filing_info__title_normal':                    'Filed in:',
                    'filing_info__title_smart':                     'Smart Filed in:',
                    'filing_info__default_notebook':                'Default',
                    'filing_info__view':                            'View',
                    'filing_info__edit':                            'Edit',
                    'filing_info__sentence':                        'Clipped into the [=notebook] notebook, and tagged with [=tags].',
                    'filing_info__sentence_no_tags':                'Clipped into the [=notebook] notebook.',
                    'filing_info__sentence_and':                    'and',
                    'filing_info__sentence_other_tags':             'other tags',
            
                    /* === */
                    
                    'evernote_clipping':                            'Clipping...',
                    'evernote_clipping_failed':                     'Clipping failed.',
                    
                    'evernote_login__request':                      'To sign in to Evernote, please click the Clearly icon in Chrome\'s toolbar.',
                    
                    'evernote_login__heading':                      'Sign in to Evernote',
                    'evernote_login__spinner':                      'Signing in to Evernote',
                    'evernote_login__create_account':               'Create an account',
                    'evernote_login__button_do__label':             'Sign in',
                    'evernote_login__button_cancel__label':         'Cancel',
                    
                    'evernote_login__username__label':              'Evernote Username or Email Address',
                    'evernote_login__password__label':              'Password',
                    'evernote_login__rememberMe__label':            'Remember me',
            
                    'evernote_login__username__error__required':    'Username is required.',
                    'evernote_login__username__error__length':      'Username must be between 1 and 64 characters long.',
                    'evernote_login__username__error__format':      'Username contains bad characters.',
                    'evernote_login__username__error__invalid':     'Not a valid, active user.',
                    
                    'evernote_login__password__error__required':    'Password is required.',
                    'evernote_login__password__error__length':      'Password must be between 6 and 64 characters long.',
                    'evernote_login__password__error__format':      'Password contains bad characters.',
                    'evernote_login__password__error__invalid':     'Username and password do not match existing user.',
                    'evernote_login__password__error__timeout':     'Login session timed-out. Please try again.',
            
                    'evernote_login__password__error__reset':       'Your password has expired. Please reset it now.',
                    'evernote_login__general__error':               'Authentication failed.',
            
                    'evernote_two_factor__message__sms':            'We sent a text message with a verification code to',
                    'evernote_two_factor__message__google':         'Enter the verification code displayed in your Google Authenticator app.',
            
                    'evernote_two_factor__code__label':             'Verification code',
                    'evernote_two_factor__code__error__required':   'Verification code is required.',
                    'evernote_two_factor__code__error__length':     'Verification code should be at least 6 characters long.',
                    'evernote_two_factor__code__error__format':     'Verification code should be only numbers.',
                    'evernote_two_factor__code__error__invalid':    'Verification code is incorrect.',
                    
                    'evernote_two_factor__button_do__label':        'Verify',
                    'evernote_two_factor__button_help__label':      'I need help getting a verification code',
            
                    /* === */
            
                    'settings__theme__1__not_translated':           'Newsprint',
                    'settings__theme__2__not_translated':           'Notable',
                    'settings__theme__3__not_translated':           'Night Owl',
                    
                    'settings__theme__1':                           'Newsprint',
                    'settings__theme__2':                           'Notable',
                    'settings__theme__3':                           'Night Owl',
                    'settings__theme__custom':                      'Custom',
                    
                    'settings__fontSize__small':                    'small',
                    'settings__fontSize__medium':                   'medium',
                    'settings__fontSize__large':                    'large',
                    
                    /* === */
                    
                    'features__title__new':                         'You have a new version of Evernote Clearly!',
                    'features__title__all':                         'Welcome to the new Evernote Clearly',
            
                    'features__speech__title':                      'Text To Speech',
                    'features__speech__text':                       'Sit back and let Clearly read blog posts, articles, and web pages to you thanks to the new Text To Speech feature, available exclusively for Evernote Premium subscribers.',
                    'features__speech__text__powered':              'Evernote Clearly is powered by [=service].',
                    'features__speech__text__requires':             'Requires [=product].',
                    'features__speech__text__available':            'Text To Speech in 21 languages:',
                    'features__speech__text__available_languages':  'English, Japanese, Spanish, French, German, Chinese, Korean, Arabic, Czech, Danish, Dutch, Finnish, Greek, Hungarian, Italian, Norwegian, Polish, Portuguese, Russian, Swedish and Turkish.',
                    'features__speech__text__try':                  'Try Text To Speech',
                    'features__speech__text__upgrade':              'Upgrade to Evernote Premium',
                    'features__speech__text__language':             'Language not supported',
                    'features__speech__text__play':                 'Play using this language',
                    'features__speech__text__cancel':               'Cancel',
                    'features__speech__no_language_title':          'Language not supported',
                    'features__speech__no_language_explanation':    'Evernote Clearly was not able to determine the language of this article. If you recognize the language, select it below and we\'ll play it.',
                    
                    'features__clipping__title':                    'Clip to Evernote',
                    'features__clipping__text':                     'Save what you\'re reading to your Evernote account with one click. Access clips from any device, anytime in Evernote.',
            
                    'features__highlighting__title':                'Highlighting',
                    'features__highlighting__text':                 'Highlight text you want to remember & quickly find it in your Evernote account. Highlighting changes you make in Clearly will be updated in your Evernote account automatically.',
            
                    'features__related_notes__title':               'Related Notes',
                    'features__related_notes__text':                'Magically rediscover notes from your Evernote account that are related to the page you are viewing. Related Notes are displayed at the bottom of the article or on the right side if space permits.',
            
                    'features__smart_filing__title':                'Smart Filing',
                    'features__smart_filing__text':                 'Automatically assign tags to your Web clips and saves them to the appropriate notebook, so you don\'t have to.',
                    
                    'features__eula_notice':                        'By using Clearly, you agree to our [=eula].',
                    'features__close2':                             'Close',
            
                    /* === */
                    
                    'misc__page':    'page'
                };    
            
            /* =============== */
            $R.translation__items = _translations_in_page;
        })();
        
    })(window.__readable_by_evernote);


//  import _js_in_background/
//  =========================
    (function ($R) {

        
        //  get options
        //  ===========
            $R.saved__get_options = function ()
            {
                var _return = {};
                for (var _x in $R.default_options) {
                    _return[_x] = $R.storage__get(_x);
                }
                return _return;
            };
        
                
        //  get vars    
        //  ========
            $R.saved__get_vars = function ()
            {
                var _return = {};
                for (var _x in $R.default_vars) {
                    _return[_x] = $R.storage__get(_x);
                }
                return _return;
            };
        
        
        //  device id
        //  =========
            $R.saved__get_device_id = function ()
            {
                var _curr = $R.storage__get('storedEvernoteDeviceId');
                if (_curr) {}else
                {
                    _curr = Math.floor((Math.random() * 1000 * 1000 * 1000)+1);
                    $R.storage__set('storedEvernoteDeviceId', _curr);
                }
                
                return _curr;
            };
            
            
        //  selects
        //  =======    
        
            $R.saved__select__theme = function (_theme_id)
            {
                //  var
                var _to_save = {};
                
                if (_theme_id == 'custom')
                {
                    _to_save = { 'theme': 'custom' };
                    var _vars = $R.saved__get_vars();
                    $R.decode(_vars['custom_theme_options']).replace(
                        /\[\[=(.*?)\]\[=(.*?)\]\]/gi,
                        function (_match, _name, _value) {
                            _to_save[_name] = _value;
                        });
                    $R.storage__set_more(_to_save);
                }
                else
                {
                    _to_save = $R.the_themes[_theme_id];
                    _to_save['theme'] = _theme_id;
                    $R.storage__set_more(_to_save);
                }
            };
            
            $R.saved__select__size = function (_size)
            {
                var _current_vars = $R.saved__get_vars();
                $R.storage__set('text_size', $R.the_sizes[_size][_current_vars['theme']]);
            };
            
            $R.saved__select__related_notes = function (_setting)
            {
                $R.storage__set('related_notes', $R.encode(_setting));
            };
            
        
        //  do logout?
        //  ==========
            $R.credentials__get_logout_on_next_action = function ()
            {
                //  get
                var _got_value = $R.storage__get('storedEvernoteLogoutOnNextAction');
            
                //  fail
                if (_got_value == 'yes') {}else { return false; }
                
                //  reset
                $R.storage__set('storedEvernoteLogoutOnNextAction', '');
                
                return true;
            };
            
        
        //  set logout!
        //  ===========
            $R.credentials__set_logout_on_next_action = function ()
            {
                $R.storage__set('storedEvernoteLogoutOnNextAction', 'yes');
            };
            
            
        //  get userInfoCache
        //  =================
            $R.credentials__getUserInfoCache = function ()
            {
                var _json = $R.storage__get('storedEvernoteUserInfo');
                if (_json > ''){} else { return false; }
                
                var _info = JSON.parse(_json);
                var _keys = ['user__id', 'user__shard_id', 'user__privilege', 'user__name', 'user__username', 'user__email', 'user__business_id', 'user__last_updated'];
                for (var _i=0, _ii=_keys.length; _i<_ii; _i++) { if (_info[_keys[_i]]){} else { return false; } }
                
                return _info;
            };
        
            
        //  set userInfoCache
        //  =================
            $R.credentials__setUserInfoCache = function (_userInfo)
            {
                var _json = JSON.stringify(_userInfo);
                $R.storage__set('storedEvernoteUserInfo', _json);
            };
        
        
        //  delete userInfoCache
        //  ====================
            $R.credentials__deleteUserInfoCache = function ()
            {
                $R.storage__set('storedEvernoteUserInfo', '');
            };
        
        
        //  get translations
        //  ================
            $R.translation__get_items = function ()
            {
                for (var x in $R.translation__items)
                {
                    var _t = $R.translation__get_item(x);
                    if (_t > '') {}else { continue; }
                
                    $R.translation__items[x] = _t;
                }
            };
        
    
        
        //  namespace
        //  =========
            $R.$bootstrap =
            {
                /* predefined */
                'servers':                  false,
                'server_main':              '',     /* ends in slash */
                'server_china':             '',     /* ends in slash */
                
                /* set on load */
                'saved_server':             false,  /* main | china */
                'client_locale':            false,
                'has_chinese_locale':       false,
                'simulate_chinese_locale':  false,
                
                /* set on bootstrap() */
                'rpc__userStore':           false,
                'profiles':                 false,
                'profiles_as_string':       false,
                'profiles_as_string2':      false,
                'server':                   false,
                'remote_domain':            false,  /* ends in slash */
                'remote_domain_marketing':  false,  /* ends in slash */
                'connected':                false
            };
        
            
        //  servers
        //  =======
            $R.$bootstrap.servers = {
                'live':     { 'main': 'https://www.evernote.com/',      'china': 'https://app.yinxiang.com/' },
                'stage':    { 'main': 'https://stage.evernote.com/',    'china': 'https://stage-china.evernote.com/' }
            };
            //  /* alternate stage => 'https://stage-dev.corp.etonreve.com/' */
            //  $R.$bootstrap.servers['live'] = $R.$bootstrap.servers['stage'];
                
                
        //  include
        //  =======
                
            //  bootstrap
            //  =========
                $R.$bootstrap.bootstrap = function (_onSuccess, _onFailure)
                {
                    //  already connected
                    //  =================
                        if ($R.$bootstrap.connected) { _onSuccess(); return; }
                
                    //  figure out order
                    //  ================
                        var _order = [];
                        switch (true)
                        {
                            case ($R.$bootstrap.saved_server == 'main'):    _order = ['main', 'china']; break;
                            case ($R.$bootstrap.saved_server == 'china'):   _order = ['china', 'main']; break;
                            case ($R.$bootstrap.has_chinese_locale):        _order = ['china', 'main']; break;
                            case ($R.$bootstrap.simulate_chinese_locale):   _order = ['china', 'main']; break;
                            default:                                        _order = ['main', 'china']; break;
                        }
            
                    //  try connect to one
                    //  ==================
                        var _try_connect_to_one = function (_order_number)
                        {
                            //  invalid number; failed
                            //  ======================
                                if (_order[_order_number]) {}else { _onFailure('connection / invalid'); return; };
            
                            //  try current number
                            //  ==================
                                var _rpcBootstrapClient = new $R.JSONRpcClient(
                                    function ()
                                    { 
                                        //  error / timeout
                                        //  ===============
                                            if (this.UserStore) {}else { _try_connect_to_one(_order_number + 1); return; }
            
                                        //  set conected
                                        //  ============
                                            $R.$bootstrap.connected = true;
                                            $R.$bootstrap.rpc__userStore = this;
            
                                        //  get profiles
                                        //  ============
                                            $R.$bootstrap.rpc__userStore.UserStore.getBootstrapInfo(
                                                function (_rpc_result, _rpc_exception)
                                                {
                                                    var _bootstrapInfoResult = _rpc_result, _bootstrapInfoError = _rpc_exception;
                                                    
                                                    //  error
                                                    //  =====
                                                        if (_bootstrapInfoError)
                                                        {
                                                            _bootstrapInfoResult = {
                                                                'profiles': {
                                                                   'list': [ {
                                                                        'name':         'Evernote',
                                                                        'setName':      true,
                                                                        'setSettings':  true,
                                                                        'settings': {
                                                                            'marketingUrl': 'http://www.evernote.com',
                                                                            'serviceHost':  'www.evernote.com',
                                                                            'supportUrl':   'https://evernote.com/contact/support/'
                                                                        }
                                                                    } ] 
                                                                }
                                                            };
                                                        }
                                                    
                                                    //  result
                                                    //  ======
                                                    
                                                        //  set profiles
                                                        //  ============
                                                            $R.$bootstrap.profiles = _bootstrapInfoResult.profiles.list;
                                                        
                                                        //  profiles as string
                                                        //  ==================
                                                            $R.$bootstrap.profiles_as_string = '';
                                                            for (var zz=0,_zz=$R.$bootstrap.profiles.length; zz<_zz; zz++)
                                                                { $R.$bootstrap.profiles_as_string += '_' + $R.$bootstrap.getProfileName__short($R.$bootstrap.profiles[zz]); }
                                                            $R.$bootstrap.profiles_as_string = $R.$bootstrap.profiles_as_string.substr(1);
                                                            $R.$bootstrap.profiles_as_string2 = $R.$bootstrap.profiles_as_string.replace(/_/g, '-');
                                                        
                                                        //  select first
                                                        //  ============
                                                            $R.$bootstrap.server = $R.$bootstrap.getProfileName__long($R.$bootstrap.profiles[0]);
                                                            $R.$bootstrap.remote_domain = $R.$bootstrap['server_' + $R.$bootstrap.server];
                                                            $R.$bootstrap.remote_domain_marketing = $R.$bootstrap.profiles[0].settings.marketingUrl + '/';
                                                        
                                                        //  first different than saved -- switch
                                                        //  ==========================
                                                            if (true && ($R.$bootstrap.profiles_as_string == 'in_cn') && ($R.$bootstrap.server == 'main') && ($R.$bootstrap.saved_server == 'china'))
                                                            {
                                                                $R.$bootstrap.server = 'china';
                                                                $R.$bootstrap.remote_domain = $R.$bootstrap['server_' + 'china'];
                                                                $R.$bootstrap.remote_domain_marketing = $R.$bootstrap.profiles[1].settings.marketingUrl + '/';
                                                                $R.$bootstrap.profiles_as_string == 'cn_in';
                                                            }
                                                            else if (true && ($R.$bootstrap.profiles_as_string == 'cn_in') && ($R.$bootstrap.server == 'china') && ($R.$bootstrap.saved_server == 'main'))
                                                            {
                                                                $R.$bootstrap.server = 'main';
                                                                $R.$bootstrap.remote_domain = $R.$bootstrap['server_' + 'main'];
                                                                $R.$bootstrap.remote_domain_marketing = $R.$bootstrap.profiles[1].settings.marketingUrl + '/';
                                                                $R.$bootstrap.profiles_as_string == 'in_cn';
                                                            }
                                                        
                                                        //  run sucess
                                                        //  ==========
                                                            _onSuccess();
                                                },
                                                ($R.$bootstrap.simulate_chinese_locale ? 'zh_cn' : $R.$bootstrap.client_locale));
                                    }, 
                                    $R.$bootstrap['server_' + _order[_order_number]] + 'json');
                        };
            
                    //  try first
                    //  =========
                        _try_connect_to_one(0);
                };
            
            
            //  profiles
            //  ========
            
                $R.$bootstrap.getProfileName__short = function (_profile)
                {
                    switch (_profile.name.toLowerCase())
                    {
                        case 'evernote':            return 'in';
                        case 'evernote-china':      return 'cn';
                    //  case 'stage':               return 'in';
                    //  case 'stagedev':            return 'in';
                    //  case 'stage-china':         return 'cn';
                    }
                    return '';
                };
                
                $R.$bootstrap.getProfileName__long = function (_profile)
                {
                    switch (_profile.name.toLowerCase())
                    {
                        case 'evernote':            return 'main';
                        case 'evernote-china':      return 'china';
                    //  case 'stage':               return 'main';
                    //  case 'stagedev':            return 'main';
                    //  case 'stage-china':         return 'cn';
                    }
                    return '';
                };
            
            
            //  set locale
            //  ==========    
                $R.$bootstrap.setLocale = function (_browser_locale)
                {
                    //  which
                    var _locale = _browser_locale;
                        _locale = _locale.replace(/[-]/gi, '_');
                        _locale = _locale.replace(/\s+/gi, '');
                        _locale = _locale.toLowerCase();
                    
                    //   set
                    $R.$bootstrap.client_locale = _locale;
                    
                    //  chinese?
                    $R.$bootstrap.has_chinese_locale = ('|zh|zh_cn|zh_hans|zh_hans_cn|'.indexOf('|'+_locale+'|') > -1);
                };
            
            
            //  disconnect
            //  ==========
                $R.$bootstrap.disconnect = function ()
                {
                    $R.$bootstrap['connected'] =      false;
                    $R.$bootstrap['profiles'] =       false;
                    $R.$bootstrap['server'] =         false;
                    $R.$bootstrap['remote_domain'] =  false;
                    $R.$bootstrap['rpc__userStore'] = false;
                };
            
            
            //  initialize
            //  ==========
                $R.$bootstrap.initialize = function ()
                {
                    //  set to live
                    $R.$bootstrap.set_servers_to_live();
                
                    //  set locale
                    $R.$bootstrap.setLocale(window.navigator.language);
            
                    //  saved server
                    if ($R.credentials__get())
                    {
                        var _credentials = $R.credentials__get();
                        if (_credentials && _credentials.server) { $R.$bootstrap.saved_server = _credentials.server; }
                    }
                };
            
            
            //  QA
            //  ==
            
                $R.$bootstrap.set_servers_to_stage = function ()
                {
                    $R.$bootstrap['server_main'] = $R.$bootstrap.servers['stage']['main'];
                    $R.$bootstrap['server_china'] = $R.$bootstrap.servers['stage']['china'];
                };
                
                $R.$bootstrap.set_servers_to_live = function ()
                {
                    $R.$bootstrap['server_main'] = $R.$bootstrap.servers['live']['main'];
                    $R.$bootstrap['server_china'] = $R.$bootstrap.servers['live']['china'];
                };
            
                $R.$bootstrap.set_simulate_chinese_locale = function () { $R.$bootstrap.simulate_chinese_locale = true; };
                $R.$bootstrap.set_do_not_simulate_chinese_locale = function () { $R.$bootstrap.simulate_chinese_locale = false; };
                
        
        
        //  namespace
        //  =========
            $R.$remote =
            {
                /* predefined */
                /* ========== */
                    'api__key':                             'en-ff-clearly-xauth-new',
                    'api__secret':                          '8ad13eca201a80fa',
        
                /* set on init */
                /* =========== */
                    'setting__related_notes':               '',
                    'setting__smart_filing':                '',
                    'setting__smart_filing_for_business':   '',
                    'setting__clip_tag':                    '',
                    'setting__clip_notebook':               '',
                    'setting__clip_notebook_guid':          '',
                    'setting__open_notes_in':               '',
                
                /* stores */
                /* ====== */
                    'store__id_to_guid':                    {},
                    'store__id_to_info':                    {},
                    'store__id_to_recommendation':          {},
        
                /* set on login */
                /* ============ */
                    'rpc__userStore':                       false,
                    'rpc__noteStore':                       false,
                    'user__authToken':                      false,
                    'user__expires':                        false,
                    'user__id':                             false,
                    'user__shardId':                        false,
                    'user__privilege':                      false,
                    'user__username':                       false,
                    'user__email':                          false,
                    'is__connected':                        false,
                    'is__loggedIn':                         false,
                    'twoFactor__authToken':                 false,
                    'twoFactor__deliveryHint':              false,
        
                /* business */
                /* ======== */
                    'is__business':                         false,
                    'business__authToken':                  false,
                    'business__expires':                    false,
                    'business__shardId':                    false,
                    'business__noteStore':                  false
            };
            
            
        //  include
        //  =======
        
            
            //  connect
            //  =======
                $R.$remote.connect = function (_onSuccess, _onFailure)
                {
                    //  bootstrap first
                    //  ===============
                        $R.$bootstrap.bootstrap(
                            function ()
                            {
                                //  bootstrap succesfull
                                //  ====================
                                try
                                {
                                    var _rpcUserStoreClient = new $R.JSONRpcClient(
                                        function ()
                                        {
                                            //  error / timeout
                                            //  ===============
                                                if (this.UserStore) {}else { _onFailure('connection / invalid'); return; }
                                        
                                            //  set conected
                                            //  ============
                                                $R.$remote.is__connected = true;
                                                $R.$remote.rpc__userStore = this;
                                            
                                            //  run success
                                            //  ===========
                                                _onSuccess();
                                        }, 
                                        $R.$bootstrap.remote_domain + 'json');
                                }
                                catch (_error) { _onFailure('connection / invalid'); return; }
                            },
                            function () { _onFailure('connection / invalid'); });
                };
            
            
            //  refresh
            //  =======
                $R.$remote.refresh_settings = function ()
                {
                    //  shortcuts
                    //  =========
                        var _s = $R.saved__get_vars(),
                            _r = $R.$remote,
                            _d = $R.decode;
            
                    //  update
                    //  ======
                        $R.$remote.setting__related_notes =             _d(_s['related_notes']);
                        $R.$remote.setting__smart_filing =              _d(_s['smart_filing']);
                        $R.$remote.setting__smart_filing_for_business = _d(_s['smart_filing_for_business']);
                        $R.$remote.setting__open_notes_in =             _d(_s['open_notes_in']);
                        $R.$remote.setting__clip_tag =                  _d(_s['clip_tag']);
                        $R.$remote.setting__clip_notebook =             _d(_s['clip_notebook']);
                        $R.$remote.setting__clip_notebook_guid =        _d(_s['clip_notebook_guid']);
                };
            
        
            
            //  not expired
            //  ===========
                $R.$remote.is__notExpired = function ()
                {
                    //  invalid
                    switch (true)
                    {
                        case (!$R.$remote.is__connected):
                        case (!$R.$remote.is__loggedIn):
                        case (!$R.$remote.user__expires):
                            return false;
                    }
                    
                    //  now
                    var _now = (new Date()).getTime();
            
                    //  not within 3 minutes of expiration
                    if (_now > ($R.$remote.user__expires - (3 * 60 * 1000))) { return false; }
                    
                    //  check business too
                    if ($R.$remote.is__business)
                    {
                        //  not within 3 minutes of expiration
                        if (_now > ($R.$remote.business__expires - (3 * 60 * 1000))) { return false; }
                        
                        //  business too, is not expired
                        return true;
                    }
                    else
                    {
                        //  not business, and user not expired
                        return true;
                    }
                    
                    return false;
                };
            
                
            //  login
            //  =====
                $R.$remote.loginLongSession = function (_user, _pass, _device_id, _device_description, _onSuccess, _onFailure)
                {
                    //  login function
                    //  ===============
                        var _loginFunction = function ()
                        {
                            //  login
                            //  =====
                                $R.$remote.rpc__userStore.UserStore.authenticateLongSession(
                                    function (_rpc_result, _rpc_exception)
                                    {
                                        var _loginResult = _rpc_result, _loginError = _rpc_exception;
                                        //console.log(_loginResult);
                                        
                                        //  error
                                        //  =====
                                        
                                            if (_loginError)
                                            {
                                                //  unknown error
                                                //  =============
                                                    switch (true)
                                                    {
                                                        case (!(_loginError.trace)):
                                                        case (!(_loginError.trace.indexOf)):
                                                        case (!(_loginError.trace.indexOf(')') > -1)):
                                                            _onFailure('login / exception / no trace');
                                                            return;
                                                    }
                                                
                                                //  figure out error
                                                //  ================
                                                    var _trace = _loginError.trace.substr(0, _loginError.trace.indexOf(')')+1);
                                                    switch (_trace)
                                                    {
                                                        case 'EDAMUserException(errorCode:INVALID_AUTH, parameter:username)':
                                                            _onFailure('username');
                                                            return;
            
                                                        case 'EDAMUserException(errorCode:INVALID_AUTH, parameter:password)':
                                                            _onFailure('password');
                                                            return;
            
                                                        case 'EDAMUserException(errorCode:AUTH_EXPIRED, parameter:password)':
                                                            _onFailure('password-reset');
                                                            return;
                                                    }
            
                                                //  could not figure out error
                                                //  ==========================
                                                    _onFailure('login / exception / unknown');
                                                    return;
                                            }
                                            
                                        
                                        //  result
                                        //  ======
                                         
                                            //  two factor
                                            //  ==========
                                            
                                                if (_loginResult.secondFactorRequired)
                                                {
                                                    //  set
                                                    $R.$remote.twoFactor__authToken = _loginResult.authenticationToken;
                                                    $R.$remote.twoFactor__deliveryHint = (_loginResult.secondFactorDeliveryHint ? _loginResult.secondFactorDeliveryHint : '');
                                                    $R.$remote.twoFactor__username = _user;
                                                
                                                    //  trigger
                                                    _onFailure('two-factor');
                                                    
                                                    //  return
                                                    return;
                                                }
                                         
                                            
                                            //  check
                                            //  =====
                                                switch (true)
                                                {
                                                    case (!(_loginResult.authenticationToken)):
                                                    case (!(_loginResult.user)):
                                                    case (!(_loginResult.user.id)):
                                                    case (!(_loginResult.user.shardId)):
                                                        _onFailure('login / invalid result');
                                                        return;
                                                }
            
                                                
                                            //  loginWithAuthToken
                                            //  ==================
                                                $R.credentials__deleteUserInfoCache();
                                                $R.$remote.loginWithAuthToken(
                                                    _loginResult.authenticationToken,
                                                    _onSuccess,
                                                    _onFailure);
                                                return;
                                    },
                                    _user,
                                    _pass,
                                    $R.$remote.api__key,
                                    $R.$remote.api__secret,
                                    _device_id,
                                    _device_description,
                                    true);
                        };
            
                        
                    //  already connected, connect, or error
                    //  =====================================
                        if ($R.$remote.is__connected)
                        {
                            //  do
                            _loginFunction();
                        }
                        else
                        {
                            //  connect
                            $R.$remote.connect(
                                function () { _loginFunction(); },
                                function () { _onFailure('connection / invalid'); });
                        }
                };
            
            
            //  login :: second factor
            //  ======================
                $R.$remote.loginLongSessionSecondFactor = function (_temp_auth, _code, _device_id, _device_description, _onSuccess, _onFailure)
                {
                    //  login function
                    //  ===============
                        var _loginFunction = function ()
                        {
                            //  login
                            //  =====
                                $R.$remote.rpc__userStore.UserStore.completeTwoFactorAuthentication(
                                    function (_rpc_result, _rpc_exception)
                                    {
                                        var _loginResult = _rpc_result, _loginError = _rpc_exception;
                                    
                                        // console.log(_loginResult);
                                        // console.log(_loginError);
                                    
                                        //  error
                                        //  =====
                                        
                                            if (_loginError)
                                            {
                                                //  unknown error
                                                //  =============
                                                    switch (true)
                                                    {
                                                        case (!(_loginError.trace)):
                                                        case (!(_loginError.trace.indexOf)):
                                                        case (!(_loginError.trace.indexOf(')') > -1)):
                                                            _onFailure('login / exception / no trace');
                                                            return;
                                                    }
                                                
                                                //  figure out error
                                                //  ================
                                                    var _trace = _loginError.trace.substr(0, _loginError.trace.indexOf(')')+1);
                                                    switch (_trace)
                                                    {
                                                        case 'EDAMUserException(errorCode:INVALID_AUTH, parameter:oneTimeCode)':
                                                            _onFailure('code');
                                                            return;
            
                                                        case 'EDAMUserException(errorCode:AUTH_EXPIRED, parameter:authenticationToken)':
                                                            _onFailure('timeout');
                                                            return;
                                                    }
            
                                                //  could not figure out error
                                                //  ==========================
                                                    _onFailure('login / exception / unknown');
                                                    return;
                                            }
                                            
                                        
                                        //  result
                                        //  ======
                                         
                                            //  check
                                            //  =====
                                                switch (true)
                                                {
                                                    case (!(_loginResult.authenticationToken)):
                                                    case (!(_loginResult.user)):
                                                    case (!(_loginResult.user.id)):
                                                    case (!(_loginResult.user.shardId)):
                                                        _onFailure('login / invalid result');
                                                        return;
                                                }
            
                                                
                                            //  loginWithAuthToken
                                            //  ==================
                                                $R.credentials__deleteUserInfoCache();
                                                $R.$remote.loginWithAuthToken(
                                                    _loginResult.authenticationToken,
                                                    _onSuccess,
                                                    _onFailure);
                                                return;
                                    },
                                    _temp_auth,
                                    _code,
                                    _device_id,
                                    _device_description);
                        };
            
                        
                    //  already connected, connect, or error
                    //  =====================================
                        if ($R.$remote.is__connected)
                        {
                            //  do
                            _loginFunction();
                        }
                        else
                        {
                            //  connect
                            $R.$remote.connect(
                                function () { _loginFunction(); },
                                function () { _onFailure('connection / invalid'); });
                        }
                };
            
            
            //  login
            //  =====
                $R.$remote.loginWithAuthToken = function (_authToken, _onSuccess, _onFailure)
                {
                    //  fail fast
                    //  =========
                        if (_authToken > '') {}else { _onFailure('getUser / exception / no token'); return; }
                
                    //  login sucess
                    //  ============
                        var _doSuccess = function () { _onSuccess(); };
                
                    //  set token
                    //  =========
                        $R.$remote.user__authToken = _authToken;
                                                
                    //  get userInfo
                    //  ============
                        $R.$remote.updateUserInfo(
                            function ()
                            {
                                //  officially logged-in
                                //  ====================
                                    $R.$remote.user__expires =      (new Date()).getTime() + (1000 * 60 * 60 * 24 * 1);     //  one day, in milliseconds
                                    $R.$remote.is__loggedIn =       true;
                            
                                //  note store -- user first; then, if needed, business
                                //  ==========
                                    var _rpcNoteStoreClient = new $R.JSONRpcClient(
                                        function ()
                                        {
                                            //  error / timeout
                                            //  ===============
                                                if (this.NoteStore) {}else { _onFailure('getUser / note store / invalid'); return; }
            
                                            //  set connected
                                            //  =============
                                                $R.$remote.rpc__noteStore = this;
            
                                            //  not business
                                            //  ============
                                                if ($R.$remote.user__businessId > 0) {}else { _doSuccess(); return; }
                        
                                            //  is business -- try login
                                            //  ========================
                                                $R.$remote.loginToBusiness(_doSuccess, _doSuccess);
                                        },
                                        $R.$bootstrap.remote_domain + 'shard/' + $R.$remote.user__shardId + '/json');
                            },
                            _onFailure);
                };
            
            
            //  login to business
            //  =================
                $R.$remote.loginToBusiness = function (_onSuccess, _onFailure)
                {
                    //  login sucess
                    //  ============
                        var _doSuccess = function () { _onSuccess(); };
            
                    //  authenticate to business
                    //  ========================
                        $R.$remote.rpc__userStore.UserStore.authenticateToBusiness(
                            function (_rpc_result, _rpc_exception)
                            {
                                var _loginResultBusiness = _rpc_result, _loginErrorBusiness = _rpc_exception;
                                
                                //  error
                                //  =====
                                    if (_loginErrorBusiness) { _doSuccess(); return; }
                                    
                                //  result
                                //  ======
                                    
                                    //  check
                                    //  =====
                                        switch (true)
                                        {
                                            case (!(_loginResultBusiness.authenticationToken)):
                                            case (!(_loginResultBusiness.user)):
                                            case (!(_loginResultBusiness.user.shardId)):
                                                _doSuccess();
                                                return;
                                        }
                                        //  console.log(_loginResultBusiness);
            
                                    //  set business info
                                    //  =================
                                        $R.$remote.business__authToken =  _loginResultBusiness.authenticationToken;
                                        $R.$remote.business__expires =    _loginResultBusiness.expiration;
            
                                        $R.$remote.business__shardId =    _loginResultBusiness.user.shardId;
                                        
                                        //  console.log(_loginResultBusiness);
                                        
                                        
                                    //  note store
                                    //  ==========
                                        var _rpcNoteStoreClientBusiness = new $R.JSONRpcClient(
                                            function ()
                                            {
                                                //  error / timeout
                                                //  ===============
                                                    if (this.NoteStore) {}else { _onFailure(); return; }
            
                                                //  set connected
                                                //  =============
                                                    $R.$remote.is__business = true;
                                                    $R.$remote.business__noteStore = this;
                                                    
                                                //  success
                                                //  =======
                                                    _doSuccess();
                                            },
                                            $R.$bootstrap.remote_domain + 'shard/' + $R.$remote.business__shardId + '/json');
                            },
                            $R.$remote.user__authToken);
                };
            
            //  token
            //  =====
                $R.$remote.logoutWithAuthToken = function (_authToken)
                {
                    try { $R.$remote.rpc__userStore.UserStore.revokeLongSession(_authToken); } catch (e) { }
                };
            
            
            //  logout
            //  ======
                $R.$remote.logout = function ()
                {
                    $R.$remote['is__connected'] =       false;
                    $R.$remote['is__loggedIn'] =        false;
                    $R.$remote['is__business'] =        false;
            
                    $R.$remote['rpc__userStore'] =      false;
                    $R.$remote['rpc__noteStore'] =      false;
            
                    $R.$remote['user__authToken'] =     false;
                    $R.$remote['user__expires'] =       false;
                    $R.$remote['user__id'] =            false;
                    $R.$remote['user__shardId'] =       false;
                    $R.$remote['user__privilege'] =     false;
                    $R.$remote['user__username'] =      false;
                    $R.$remote['user__email'] =         false;
            
                    $R.$remote['business__noteStore'] = false;
                    $R.$remote['business__authToken'] = false;
                    $R.$remote['business__expires'] =   false;
                    $R.$remote['business__shardId'] =   false;
                };
            
            
            //  QA
            //  ==
                $R.$remote.disconnect = function () { $R.$remote.logout(); };
                
            
            //  login
            //  =====
                $R.$remote.updateUserInfo__getFromServer = function (_onSuccess, _onFailure)
                {
                    $R.$remote.rpc__userStore.UserStore.getUser(
                        function (_rpc_result, _rpc_exception)
                        {
                            var _getUserResult = _rpc_result, _getUserError = _rpc_exception;
                        
                            if (_getUserError)
                            {
                                //  could not figure out error
                                //  ==========================
                                    _onFailure('getUser / exception / unknown');
                                    return;
                            }
                                
                            switch (true)
                            {
                                case (!(_getUserResult)):
                                case (!(_getUserResult.id)):
                                case (!(_getUserResult.shardId)):
                                    _onFailure('getUser / invalid result');
                                    return;
                            }
            
                            $R.$remote.user__id =           _getUserResult.id;
                            $R.$remote.user__shardId =      _getUserResult.shardId;
                            $R.$remote.user__privilege =    _getUserResult.privilege.value;
                            $R.$remote.user__name =         _getUserResult.name;
                            $R.$remote.user__username =     _getUserResult.username;
                            $R.$remote.user__email =        _getUserResult.email;
                            $R.$remote.user__businessId =   ((true && _getUserResult.accounting && _getUserResult.accounting.businessId && (_getUserResult.accounting.businessId > 0)) ? _getUserResult.accounting.businessId : 0);
                            $R.$remote.user__lastUpdated =  _getUserResult.updated;
                                
                            _onSuccess(); 
                        },
                        $R.$remote.user__authToken);
                };
            
                $R.$remote.updateUserInfo = function (_onSuccess, _onFailure)
                {
                    //  current cache
                    //  =============
                        var _currentCache = $R.credentials__getUserInfoCache();
                    
                    //  get and cache userInfo
                    //  =================
                        var _getAndCacheUserInfo = function ()
                        {
                            $R.$remote.updateUserInfo__getFromServer(
                                function ()
                                {
                                    //  the new cache
                                    var _newCache = {
                                        'user__id':           $R.$remote.user__id,
                                        'user__shard_id':     $R.$remote.user__shardId,
                                        'user__privilege':    $R.$remote.user__privilege,
                                        'user__name':         $R.$remote.user__name,
                                        'user__username':     $R.$remote.user__username,
                                        'user__email':        $R.$remote.user__email,
                                        'user__business_id':  $R.$remote.user__businessId,
                                        'user__last_updated': $R.$remote.user__lastUpdated
                                    };
                                    
                                    //  save cache
                                    $R.credentials__setUserInfoCache(_newCache);
                                    
                                    //  success
                                    _onSuccess();
                                },
                                _onFailure);
                        };
                    
                    //  get syncStateAndCompareCache
                    //  ============================
                        var _getSyncStateAndCompareCacheDate = function ()
                        {
                            var _rpcNoteStoreClient_dummy = new $R.JSONRpcClient(
                                function ()
                                {
                                    //  error / timeout
                                    //  ===============
                                        if (this.NoteStore) {}else { _onFailure('getUser / note store / invalid'); return; }
            
                                    //  getSyncState
                                    //  ============
                                        this.NoteStore.getSyncState(
                                            function (_rpc_result, _rpc_exception)
                                            {
                                                var _last__online = ((_rpc_result && _rpc_result.lastUpdated && (_rpc_result.lastUpdated > 0)) ? _rpc_result.lastUpdated : 0);
                                                var _last__cached = ((_currentCache.user__last_updated && (_currentCache.user__last_updated > 0)) ? _currentCache.user__last_updated : 0);
                                    
                                                //  get from online, or set cached
                                                if ((_last__online > _last__cached) || ((_last__online + _last__cached) == 0))
                                                {
                                                    _getAndCacheUserInfo();
                                                }
                                                else
                                                {
                                                    //  set from local cache
                                                    //  ====================
                                                        $R.$remote.user__id =           _currentCache['user__id'];
                                                        $R.$remote.user__shardId =      _currentCache['user__shard_id'];
                                                        $R.$remote.user__privilege =    _currentCache['user__privilege'];
                                                        $R.$remote.user__name =         _currentCache['user__name'];
                                                        $R.$remote.user__username =     _currentCache['user__username'];
                                                        $R.$remote.user__email =        _currentCache['user__email'];
                                                        $R.$remote.user__businessId =   _currentCache['user__business_id'];
                                                        $R.$remote.user__lastUpdated =  _currentCache['user__last_updated'];
            
                                                    //  success
                                                    //  =======
                                                        _onSuccess();
                                                }
                                            }, 
                                            __readable_by_evernote.$remote.user__authToken);
            
                                },
                                $R.$bootstrap.remote_domain + 'shard/' + _currentCache['user__shard_id'] + '/json');
                        };
            
                    //  getUserInfo
                    //  ===========
                        var _getUserInfo = function ()
                        {
                            if (_currentCache)
                            {
                                _getSyncStateAndCompareCacheDate();
                            }
                            else
                            {
                                _getAndCacheUserInfo();            
                            }
                        };
                    
                    //  already connected, connect, or error
                    //  ====================================
                        if ($R.$remote.is__connected)
                        {
                            //  do
                            _getUserInfo();
                        }
                        else
                        {
                            //  connect
                            $R.$remote.connect(
                                function () { _getUserInfo(); },
                                function () { _onFailure('connection / invalid'); });
                        }
                };
            
        
            
            //  clip
            //  ====
                $R.$remote.clip = function (_id, _url, _title, _body, _onSuccess, _onFailure)
                {
                    //  preliminary check
                    //  =================
                        switch (true)
                        {
                            case (!($R.$remote.rpc__noteStore)):
                            case (!($R.$remote.rpc__noteStore.NoteStore)):
                            case (!($R.$remote.is__connected)):
                            case (!($R.$remote.is__loggedIn)):
                            case (!($R.$remote.is__notExpired())):
                                _onFailure('login');
                                return;
                        }
            
            
                    //  fix title -- simple trim
                    //  =========
                        _title = ((_title > '') ? _title.replace(/^\s+|\s+$/gm, '') : _url);
            
                    //  fix title -- must match "^[^\p{Cc}\p{Z}]([^\p{Cc}\p{Zl}\p{Zp}]{0,253}[^\p{Cc}\p{Z}])?$"
                    //  =========
                        //  http://www.unicode.org/reports/tr18/#General_Category_Property
                        //  XRegExp Unicode categories: http://xregexp.com/addons/unicode/unicode-categories.js
                            //  Cc: "0000-001F 007F-009F"
                            //  Z : "0020 00A0 1680 180E 2000-200A 2028 2029 202F 205F 3000"
                            //  Zl: "2028"
                            //  Zp: "2029"
                        //  example: http://espn.go.com/blog/playbook/fandom/post/_/id/20240/carmelo-anthonys-other-love-boxing 
                            
                        var _regex__cc_z__start = /^([\u0000-\u001F\u007F-\u009F]|[\u0020\u00A0\u1680\u180E\u2000-\u200A\u2028\u2029\u202F\u205F\u3000])/i,
                            _regex__cc_z__end =    /([\u0000-\u001F\u007F-\u009F]|[\u0020\u00A0\u1680\u180E\u2000-\u200A\u2028\u2029\u202F\u205F\u3000])$/i,
                            _regex__cc_zl_zp =     /([\u0000-\u001F\u007F-\u009F]|[\u2028]|[\u2029])/gi;
                        
                        //  start: ^[^\p{Cc}\p{Z}]
                        while (_title.match(_regex__cc_z__start) != null) { _title = _title.replace(_regex__cc_z__start, ''); }
                        
                        //  end: [^\p{Cc}\p{Z}])?$
                        while (_title.match(_regex__cc_z__end) != null) { _title = _title.replace(_regex__cc_z__end, ''); }
                        
                        //  ([^\p{Cc}\p{Zl}\p{Zp}]{0,253}
                        _title = _title.replace(_regex__cc_zl_zp, '');
                        
                    //  fix title -- length
                    //  =========
                        _title = _title.substr(0, 255);
                    
            
                    //  smart filing enabled -- but the recommendation hasn't been requested yet; turn around
                    //  ====================
                        if ($R.$remote.setting__smart_filing == 'disabled') {}else
                        {
                            switch (true)
                            {
                                case ($R.$remote.setting__smart_filing == 'enabled'):
                                case ($R.$remote.setting__smart_filing == 'just_notebooks'):
                                case ($R.$remote.setting__smart_filing == 'just_tags'):
                                    if ($R.$remote.store__id_to_recommendation[_id]) {}else
                                    {
                                        //  get recommendation
                                        //  ==================
                                            $R.$remote.get_recommendation(
                                                _id,
                                                _url,
                                                _body,
                                                function ()
                                                {
                                                    //  do it again; recommendatin was added to the global store
                                                    $R.$remote.clip(_id, _url, _title, _body, _onSuccess, _onFailure);
                                                },
                                                function ()
                                                {
                                                    //  set to dummy; only try this once
                                                    $R.$remote.store__id_to_recommendation[_id] = true;
                                                    
                                                    //  do it again -- with no smart filing
                                                    $R.$remote.clip(_id, _url, _title, _body, _onSuccess, _onFailure);
                                                });
                                        
                                        //  turn around
                                        //  ===========
                                            return;
                                    }
                                    break;
                            }
                        }
                    
                        
                    //  the finling info object
                    //  =======================
                    
                        var _filingInfo = {
                            'source':                   'Clearly',
                            
                            'notebookGuid':             $R.$remote.setting__clip_notebook_guid,
                            'notebookName':             false,
                            'createNotebook':           false,
                            
                            'tagNameList':              [],
                            'tagNameObject':            {},
                            'tagNameRecommendation':    false,
                            'createTags':               true
                        };
                        
                        //  previously clipped
                        //  ==================
                            if (_id in $R.$remote.store__id_to_guid) { _filingInfo['originalNoteGuid'] = $R.$remote.store__id_to_guid[_id]; }
                        
                        //  tags from options
                        //  =================
                            var _tags_from_options = $R.$remote.setting__clip_tag.split(',');
                            for (var i=0, _i=_tags_from_options.length, _t=false; i<_i;i++)
                            {
                                _t = _tags_from_options[i].replace(/^ /, '').replace(/ $/, '');
                                if (_t > '' && !(_filingInfo.tagNameObject[_t]))
                                {
                                    _filingInfo.tagNameList.push(_t);
                                    _filingInfo.tagNameObject[_t] = true;
                                }
                            }
            
                        //  personal smart-filing
                        //  =====================
                        
                            //  notebook
                            if (true && ($R.$remote.setting__smart_filing == 'enabled' || $R.$remote.setting__smart_filing == 'just_notebooks') && $R.$remote.store__id_to_recommendation[_id] && $R.$remote.store__id_to_recommendation[_id].notebook && $R.$remote.store__id_to_recommendation[_id].notebook.guid && $R.$remote.store__id_to_recommendation[_id].notebook.name)
                            {
                                _filingInfo['notebookGuid'] = $R.$remote.store__id_to_recommendation[_id].notebook.guid;
                                _filingInfo['notebookName'] = $R.$remote.store__id_to_recommendation[_id].notebook.name;
                            }
                        
                            //  tags
                            if (true && ($R.$remote.setting__smart_filing == 'enabled' || $R.$remote.setting__smart_filing == 'just_tags') && $R.$remote.store__id_to_recommendation[_id] && $R.$remote.store__id_to_recommendation[_id].tags && $R.$remote.store__id_to_recommendation[_id].tags.list && $R.$remote.store__id_to_recommendation[_id].tags.list.length)
                            {
                                for (var i=0, _i=$R.$remote.store__id_to_recommendation[_id].tags.list.length, _t=false; i<_i;i++)
                                {
                                    _t = $R.$remote.store__id_to_recommendation[_id].tags.list[i].name;
                                    if (_t > '' && !(_filingInfo.tagNameObject[_t]))
                                    {
                                        _filingInfo.tagNameList.push(_t);
                                        _filingInfo.tagNameObject[_t] = true;
                                    }
                                }
                            }
                            
                        //  business smart-filing
                        //  =====================
                        
                            //  notebook
                            if (true && ($R.$remote.setting__smart_filing == 'enabled' || $R.$remote.setting__smart_filing == 'just_notebooks') && ($R.$remote.setting__smart_filing_for_business == 'enabled') && $R.$remote.is__business && $R.$remote.store__id_to_recommendation[_id] && $R.$remote.store__id_to_recommendation[_id].businessRecommendation && $R.$remote.store__id_to_recommendation[_id].businessRecommendation.notebook && $R.$remote.store__id_to_recommendation[_id].businessRecommendation.notebook.guid && $R.$remote.store__id_to_recommendation[_id].businessRecommendation.notebook.name)
                            {
                                _filingInfo['notebookGuid'] = $R.$remote.store__id_to_recommendation[_id].businessRecommendation.notebook.guid;
                                _filingInfo['notebookName'] = $R.$remote.store__id_to_recommendation[_id].businessRecommendation.notebook.name;
                            }
                        
                    //  try and clip
                    //  ============
            
                        //  final info
                        //  ==========
                            //console.log('filing info');
                            //console.log(_filingInfo);
                    
                        //  clip do
                        //  =======
                            var _clip_do = function (_do_filingInfo, _to_business)
                            {
                                //  which?
                                //  ======
                                    var _noteStore = (_to_business ? $R.$remote.business__noteStore : $R.$remote.rpc__noteStore),
                                        _authToken = (_to_business ? $R.$remote.business__authToken : $R.$remote.user__authToken);
                                    
                                //  filing info -- for business, ignore tags
                                //  ===========
                                
                                    //  properties
                                    var _actualFilingInfoProperties = [ 'source', 'notebookGuid', 'originalNoteGuid' ];
                                    if (_to_business) {}else
                                    {
                                        _actualFilingInfoProperties.push('tagNameList');
                                        _actualFilingInfoProperties.push('createTags');
                                    }
                                    
                                    //  copy to new filingInfo object
                                    var _actualFilingInfo = {};
                                    for (var z=0, _z=_actualFilingInfoProperties.length, _p=false; z<_z; z++)
                                    {
                                        _p = _actualFilingInfoProperties[z];
                                        if (_do_filingInfo[_p]) { _actualFilingInfo[_p] = _do_filingInfo[_p]; }
                                    }
                                    //  console.log(_actualFilingInfo);
                                    
                                //  clip
                                //  ====
                                    _noteStore.NoteStoreExtra.clipNote(
                                        function (_rpc_result, _rpc_exception)
                                        {
                                            var _clipResult = _rpc_result, _clipError = _rpc_exception;
                                        
                                            //  error
                                            //  =====
                                            
                                                if (_clipError)
                                                {
                                                    //  Firebug.Console.log(_clipError);
                                                    //  console.log(_clipError);
                                                    
                                                    //  unknown error
                                                    //  =============
                                                        switch (true)
                                                        {
                                                            case (!(_clipError.trace)):
                                                            case (!(_clipError.trace.indexOf)):
                                                            case (!(_clipError.trace.indexOf(')') > -1)):
                                                                _onFailure('clip / exception / no trace');
                                                                return;
                                                        }
                                                    
                                                    //  figure out error
                                                    //  ================
                                                        var _trace = _clipError.trace.substr(0, _clipError.trace.indexOf(')')+1);
                                                        switch (_trace)
                                                        {
                                                            case 'EDAMUserException(errorCode:BAD_DATA_FORMAT, parameter:authenticationToken)':
                                                            case 'EDAMSystemException(errorCode:INVALID_AUTH, message:authenticationToken)':
                                                            case 'EDAMUserException(errorCode:AUTH_EXPIRED, parameter:authenticationToken)':
                                                                _onFailure('login');
                                                                return;
                                                        }
            
                                                    //  could not figure out error
                                                    //  ==========================
                                                        _onFailure('clip / exception / unknown');
                                                        return;
                                                }
                                                
                                            //  result
                                            //  ======
            
                                                //  check
                                                //  =====
                                                    switch (true)
                                                    {
                                                        case (!(_clipResult > '')):
                                                        case (!(_clipResult.split('-').length == 5)):
                                                            _onFailure('clip / invalid result');
                                                            return;
                                                    }
                                                    
                                                //  store this version
                                                //  ==================
                                                    
                                                    //  guid
                                                    $R.$remote.store__id_to_guid[_id] = _clipResult;
                                                    
                                                    //  other details
                                                    $R.$remote.store__id_to_info[_id] = {
                                                        'guid':             $R.$remote.store__id_to_guid[_id],
                                                        'tag_names':        (_do_filingInfo['tagNameList'] ? _do_filingInfo['tagNameList'] : []),
                                                        'notebook_name':    (_do_filingInfo['notebookName'] ? _do_filingInfo['notebookName'] : ''),
                                                        'notebook_guid':    (_do_filingInfo['notebookGuid'] ? _do_filingInfo['notebookGuid'] : '')
                                                    };
                                                    
                                                    //  urls
                                                    var _n = $R.$remote.store__id_to_info[_id], _nURL = $R.$remote.get_note_link(_to_business, _n.guid, _n.notebook_guid);
                                                    $R.$remote.store__id_to_info[_id]['url_view'] = _nURL;
                                                    $R.$remote.store__id_to_info[_id]['url_edit'] = _nURL;
                                                    
                                                //  success
                                                //  =======
                                                    _onSuccess();
                                        },
                                        _authToken,
                                        _actualFilingInfo,
                                        _title,
                                        _url,
                                        _body);
                            };
                                
                                
                        //  do the clip -- but where?
                        //  ===========
                            
                            //  the fallabck
                            //  ============
                                var _clip_to_user_default_notebook = function (_default_filingInfo)
                                {
                                    $R.$remote.rpc__noteStore.NoteStore.getDefaultNotebook(
                                        function (_rpc_result, _rpc_exception)
                                        {
                                            var _getResult = _rpc_result, _getError = _rpc_exception;
                                            if (true && !(_getError) && _getResult && _getResult.guid && _getResult.name)
                                            {
                                                //  found default notebook
                                                //  ======================
                                                    _default_filingInfo['notebookGuid'] = _getResult.guid;
                                                    _default_filingInfo['notebookName'] = _getResult.name;
                                                    _clip_do(_default_filingInfo, false);
                                            }
                                            else
                                            {
                                                //  didn't find default notebook
                                                //  ============================
                                                    _default_filingInfo['notebookName'] = '';
                                                    delete _default_filingInfo['notebookGuid'];
                                                    _clip_do(_default_filingInfo, false);
                                            }
                                        },
                                        $R.$remote.user__authToken);
                                };
                                
                                
                            //  clip to shared notebook
                            //  =======================
                                var _clip_to_shared_notebook_or_user_default_notebook = function (_filingInfo)
                                {
                                };
            
                                
                            //  straight to user's default notebook
                            //  ===================================
                                if (_filingInfo['notebookGuid'] > '') {}else { _clip_to_user_default_notebook(_filingInfo); return; }
            
                            
                            //  try one of the user's notebooks
                            //  ===============================
                                $R.$remote.rpc__noteStore.NoteStore.getNotebook(
                                    function (_rpc_result, _rpc_exception)
                                    {
                                        var _getResult = _rpc_result, _getError = _rpc_exception;
                                        if (true && !(_getError) && _getResult && _getResult.guid && _getResult.name)
                                        {
                                            //  found user's notebook
                                            //  =====================
                                                _filingInfo['notebookName'] = _getResult.name;
                                                _clip_do(_filingInfo, false);
                                        }
                                        else if ($R.$remote.is__business)
                                        {
                                            //  try one of the user's business notebooks -- selected with proper guid
                                            //  ========================================
                                                $R.$remote.business__noteStore.NoteStore.getNotebook(
                                                    function (_rpc_result, _rpc_exception)
                                                    {
                                                        var _getResult = _rpc_result, _getError = _rpc_exception;
                                                        if (true && !(_getError) && _getResult && _getResult.guid && _getResult.name)
                                                        {
                                                            //  found business notebook
                                                            //  =======================
                                                                _filingInfo['notebookName'] = _getResult.name;
                                                                _clip_do(_filingInfo, true);
                                                        }
                                                        else
                                                        {
                                                            //  user's default notebook
                                                            _clip_to_user_default_notebook(_filingInfo);
                                                        }
                                                    },
                                                    $R.$remote.business__authToken,
                                                    _filingInfo['notebookGuid']);
                                        }
                                        else
                                        {
                                            //  user's default notebook
                                            _clip_to_user_default_notebook(_filingInfo);
                                        }
                                    },
                                    $R.$remote.user__authToken,
                                    _filingInfo['notebookGuid']);
                };
            
            
            //  recommendation
            //  ==============
                $R.$remote.get_recommendation = function (_id, _url, _body, _onSuccess, _onFailure)
                {
                    //  preliminary check
                    //  =================
                        switch (true)
                        {
                            case (!($R.$remote.rpc__noteStore)):
                            case (!($R.$remote.rpc__noteStore.NoteStore)):
                            case (!($R.$remote.is__connected)):
                            case (!($R.$remote.is__loggedIn)):
                            case (!($R.$remote.is__notExpired())):
                                _onFailure('login');
                                return;
                        }
            
                    //  get scuccess
                    //  ============
                        var _doSuccess = function () { _onSuccess(); };
                    
                    
                    //  default to false
                    //  ================
                        var _defaultResultToFalse = function (_thisResult)
                        {
                            var _theResult = _thisResult;
                            
                            if (_theResult) {}else                  { _theResult = {}; }
                            if (_theResult.notebook) {}else         { _theResult.notebook = false; }
                            if (_theResult.tags) {}else             { _theResult.tags = false; }
                            if (_theResult.relatedNotes) {}else     { _theResult.relatedNotes = false; }
                            
                            return _theResult;
                        };
                    
                    //  add absolute URLs
                    //  =================
                        var _addAbsoluteURLs = function (_addToThisResult, _use_business)
                        {
                            var _theResult = _addToThisResult;
                            
                            //  check
                            if (true && _theResult.relatedNotes && _theResult.relatedNotes.list && _theResult.relatedNotes.list.length > 0) {}else { return _theResult; }
                            
                            //  loop
                            //  ====
                                for (var i=0, _i=_theResult.relatedNotes.list.length; i<_i; i++)
                                {
                                    var _n = _theResult.relatedNotes.list[i];
                                    _theResult.relatedNotes.list[i]['absoluteURL__thumbnail'] = $R.$remote.get_note_thumbnail(_use_business, _n.guid);
                                    _theResult.relatedNotes.list[i]['absoluteURL__noteView'] = $R.$remote.get_note_link(_use_business, _n.guid, _n.notebookGuid);
                                    
                                    // no thumbnail
                                    if (_theResult.relatedNotes.list[i]['largestResourceSize'] > 0) {}else { _theResult.relatedNotes.list[i]['absoluteURL__thumbnail'] = 'none'; }
                                }
                            
                            //  return
                            return _theResult;
                        };
                        
                    //  _body
                    //  =====
                        //  just text
                        _body = _body.replace(/<[^>]+?>/gi, ' ');
                        
                        //  remove spaces
                        _body = _body.replace(/\s+/gi, ' ');
                        _body = _body.replace(/^\s+/gi, '');
                        
                        //  cut off
                        _body = _body.substr(0, 5000);
                        
                    //  recommendation request
                    //  ======================
                        var _recommendationRequest = {
                            'url': _url,
                            'text': _body,
                            'relatedNotesResultSpec': {
                                'includeTitle': true,
                                'includeSnippet': true,
                                
                                'includeCreated': true,
                                
                                'includeLargestResourceMime': true,
                                'includeLargestResourceSize': true,
                                
                                'includeNotebookGuid': true,
            
                                'includeAttributes': false,
                                'includeTagNames': false
                            }
                        };
                        //  console.log('NoteStoreExtra.getFilingRecommendations Called with:');
                        //  console.log(_recommendationRequest);
                        
                        
                    //  try and get -- a FilingReccomendation object
                    //  ===========
                        $R.$remote.rpc__noteStore.NoteStoreExtra.getFilingRecommendations(
                            function (_rpc_result, _rpc_exception)
                            {
                                var _getResult = _rpc_result, _getError = _rpc_exception;
                            
                                //  error
                                //  =====
                                
                                    if (_getError)
                                    {
                                        //  Firebug.Console.log(_getError);
                                        //  console.log(_getError);
                                        
                                        //  unknown error
                                        //  =============
                                            switch (true)
                                            {
                                                case (!(_getError.trace)):
                                                case (!(_getError.trace.indexOf)):
                                                case (!(_getError.trace.indexOf(')') > -1)):
                                                    _onFailure('get_recommendation / exception / no trace');
                                                    return;
                                            }
                                        
                                        //  figure out error
                                        //  ================
                                            var _trace = _getError.trace.substr(0, _getError.trace.indexOf(')')+1);
                                            switch (_trace)
                                            {
                                                case 'EDAMUserException(errorCode:BAD_DATA_FORMAT, parameter:authenticationToken)':
                                                case 'EDAMSystemException(errorCode:INVALID_AUTH, message:authenticationToken)':
                                                case 'EDAMUserException(errorCode:AUTH_EXPIRED, parameter:authenticationToken)':
                                                    _onFailure('login');
                                                    return;
                                            }
            
                                        //  could not figure out error
                                        //  ==========================
                                            _onFailure('get_recommendation / exception / unknown');
                                            return;
                                    }
                                    
                                //  result
                                //  ======
                                
                                    //  fill in to false
                                    //  ================
                                        _getResult = _defaultResultToFalse(_getResult);
                                    
                                    //  add absoluteURLs
                                    //  ================
                                        _getResult = _addAbsoluteURLs(_getResult, false);
                                        
                                    //  store result
                                    //  ============
                                        $R.$remote.store__id_to_recommendation[_id] = _getResult;
                                        
                                    //  not business; end
                                    //  =================
                                        if (true && $R.$remote.is__business && $R.$remote.business__noteStore && $R.$remote.business__noteStore.NoteStore) {}else { _doSuccess(); return; }
                                        
                                    //  is business; get second reccomendation
                                    //  ======================================
                                        $R.$remote.store__id_to_recommendation[_id]['businessRecommendation'] = false;
                                        
                                        $R.$remote.business__noteStore.NoteStoreExtra.getFilingRecommendations(
                                            function (_rpc_result, _rpc_exception)
                                            {
                                                var _getResultBusiness = _rpc_result, _getErrorBusiness = _rpc_exception;
                                                
                                                //  error
                                                //  =====
                                                    if (_getErrorBusiness) { _doSuccess(); return; }
                                                    
                                                //  result
                                                //  ======
                                                    
                                                    //  fill in to false
                                                    //  ================
                                                        _getResultBusiness = _defaultResultToFalse(_getResultBusiness);
                                                    
                                                    //  add absoluteURLs
                                                    //  ================
                                                        _getResultBusiness = _addAbsoluteURLs(_getResultBusiness, true);
                                                        
                                                    //  store result
                                                    //  ============
                                                        $R.$remote.store__id_to_recommendation[_id].businessRecommendation = _getResultBusiness;
            
                                                //  success
                                                //  =======
                                                    //  console.log($R.$remote.store__id_to_recommendation[_id]);
                                                    _doSuccess();
                                            },
                                            $R.$remote.business__authToken,
                                            _recommendationRequest);
                            },
                            $R.$remote.user__authToken,
                            _recommendationRequest);
                };
            
            
            //  get notebooks
            //  =============
                $R.$remote.get_notebooks = function (_onSuccess, _onFailure)
                {
                    //  preliminary check
                    //  =================
                        switch (true)
                        {
                            case (!($R.$remote.rpc__noteStore)):
                            case (!($R.$remote.rpc__noteStore.NoteStore)):
                            case (!($R.$remote.is__connected)):
                            case (!($R.$remote.is__loggedIn)):
                            case (!($R.$remote.is__notExpired())):
                                _onFailure('login');
                                return;
                        }
            
                    //  try and get -- a list of notebooks
                    //  ===========
                        $R.$remote.rpc__noteStore.NoteStore.listNotebooks(
                            function (_rpc_result, _rpc_exception)
                            {
                                var _getResult = _rpc_result, _getError = _rpc_exception;
                            
                                //  error
                                //  =====
                                
                                    if (_getError)
                                    {
                                        //  Firebug.Console.log(_getError);
                                        //  console.log(_getError);
                                        
                                        //  unknown error
                                        //  =============
                                            switch (true)
                                            {
                                                case (!(_getError.trace)):
                                                case (!(_getError.trace.indexOf)):
                                                case (!(_getError.trace.indexOf(')') > -1)):
                                                    _onFailure('get_notebooks / exception / no trace');
                                                    return;
                                            }
                                        
                                        //  figure out error
                                        //  ================
                                            var _trace = _getError.trace.substr(0, _getError.trace.indexOf(')')+1);
                                            switch (_trace)
                                            {
                                                case 'EDAMUserException(errorCode:BAD_DATA_FORMAT, parameter:authenticationToken)':
                                                case 'EDAMSystemException(errorCode:INVALID_AUTH, message:authenticationToken)':
                                                case 'EDAMUserException(errorCode:AUTH_EXPIRED, parameter:authenticationToken)':
                                                    _onFailure('login');
                                                    return;
                                            }
            
                                        //  could not figure out error
                                        //  ==========================
                                            _onFailure('get_notebooks / exception / unknown');
                                            return;
                                    }
                                    
                                //  result
                                //  ======
                                
                                    //  check
                                    //  =====
                                    
                                        switch (true)
                                        {
                                            case (!(_getResult.list)):
                                            case (!(_getResult.list.length)):
                                                _onFailure('get_notebooks / invalid result');
                                                return;
                                        }
                                    
                                    //  success
                                    //  =======
                                    
                                        //  sort
                                        //  ====
                                            _getResult.list.sort(function (a, b)
                                            {
                                                switch (true)
                                                {
                                                    case (a.name < b.name): return -1;
                                                    case (a.name > b.name): return 1;
                                                    default: return 0;
                                                }
                                            });
                                        
                                        //  return
                                        //  ======
                                            _onSuccess(_getResult.list);
                            },
                            $R.$remote.user__authToken);
                };
            
            
            //  get business notebooks
            //  ======================
                $R.$remote.get_business_notebooks = function (_onSuccess, _onFailure)
                {
                    //  preliminary check
                    //  =================
                        switch (true)
                        {
                            case (!($R.$remote.business__noteStore)):
                            case (!($R.$remote.business__noteStore.NoteStore)):
                            case (!($R.$remote.is__business)):
                            case (!($R.$remote.is__connected)):
                            case (!($R.$remote.is__loggedIn)):
                            case (!($R.$remote.is__notExpired())):
                                _onFailure('login');
                                return;
                        }
            
                    //  try and get -- a list of notebooks
                    //  ===========
                        $R.$remote.business__noteStore.NoteStore.listNotebooks(
                            function (_rpc_result, _rpc_exception)
                            {
                                var _getResult = _rpc_result, _getError = _rpc_exception;
                            
                                //  error
                                //  =====
                                
                                    if (_getError)
                                    {
                                        //  Firebug.Console.log(_getError);
                                        //  console.log(_getError);
                                        
                                        //  unknown error
                                        //  =============
                                            switch (true)
                                            {
                                                case (!(_getError.trace)):
                                                case (!(_getError.trace.indexOf)):
                                                case (!(_getError.trace.indexOf(')') > -1)):
                                                    _onFailure('get_business_notebooks / exception / no trace');
                                                    return;
                                            }
                                        
                                        //  figure out error
                                        //  ================
                                            var _trace = _getError.trace.substr(0, _getError.trace.indexOf(')')+1);
                                            switch (_trace)
                                            {
                                                case 'EDAMUserException(errorCode:BAD_DATA_FORMAT, parameter:authenticationToken)':
                                                case 'EDAMSystemException(errorCode:INVALID_AUTH, message:authenticationToken)':
                                                case 'EDAMUserException(errorCode:AUTH_EXPIRED, parameter:authenticationToken)':
                                                    _onFailure('login');
                                                    return;
                                            }
            
                                        //  could not figure out error
                                        //  ==========================
                                            _onFailure('get_business_notebooks / exception / unknown');
                                            return;
                                    }
                                    
                                //  result
                                //  ======
                                
                                    //  check
                                    //  =====
                                    
                                        switch (true)
                                        {
                                            case (!(_getResult.list)):
                                            case (!(_getResult.list.length)):
                                                _onFailure('get_business_notebooks / invalid result');
                                                return;
                                        }
                                    
                                    //  success
                                    //  =======
                                    
                                        //  sort
                                        //  ====
                                            _getResult.list.sort(function (a, b)
                                            {
                                                switch (true)
                                                {
                                                    case (a.name < b.name): return -1;
                                                    case (a.name > b.name): return 1;
                                                    default: return 0;
                                                }
                                            });
                                        
                                        //  return
                                        //  ======
                                            _onSuccess(_getResult.list);
                            },
                            $R.$remote.business__authToken);
                };
            
                
            //  get linked notebooks
            //  ====================
                $R.$remote.get_linked_notebooks = function (_onSuccess, _onFailure)
                {
                    //  preliminary check
                    //  =================
                        switch (true)
                        {
                            case (!($R.$remote.rpc__noteStore)):
                            case (!($R.$remote.rpc__noteStore.NoteStore)):
                            case (!($R.$remote.is__connected)):
                            case (!($R.$remote.is__loggedIn)):
                            case (!($R.$remote.is__notExpired())):
                                _onFailure('login');
                                return;
                        }
            
                    //  try and get -- a list of notebooks
                    //  ===========
                        $R.$remote.rpc__noteStore.NoteStore.listLinkedNotebooks(
                            function (_rpc_result, _rpc_exception)
                            {
                                var _getResult = _rpc_result, _getError = _rpc_exception;
                            
                                //  error
                                //  =====
                                
                                    if (_getError)
                                    {
                                        //  Firebug.Console.log(_getError);
                                        //  console.log(_getError);
                                        
                                        //  unknown error
                                        //  =============
                                            switch (true)
                                            {
                                                case (!(_getError.trace)):
                                                case (!(_getError.trace.indexOf)):
                                                case (!(_getError.trace.indexOf(')') > -1)):
                                                    _onFailure('get_notebooks / exception / no trace');
                                                    return;
                                            }
                                        
                                        //  figure out error
                                        //  ================
                                            var _trace = _getError.trace.substr(0, _getError.trace.indexOf(')')+1);
                                            switch (_trace)
                                            {
                                                case 'EDAMUserException(errorCode:BAD_DATA_FORMAT, parameter:authenticationToken)':
                                                case 'EDAMSystemException(errorCode:INVALID_AUTH, message:authenticationToken)':
                                                case 'EDAMUserException(errorCode:AUTH_EXPIRED, parameter:authenticationToken)':
                                                    _onFailure('login');
                                                    return;
                                            }
            
                                        //  could not figure out error
                                        //  ==========================
                                            _onFailure('get_linked_notebooks / exception / unknown');
                                            return;
                                    }
                                    
                                //  result
                                //  ======
                                
                                    //  check
                                    //  =====
                                        
                                        switch (true)
                                        {
                                            case (!(_getResult.list)):
                                            case (!(_getResult.list.length)):
                                                _onFailure('get_linked_notebooks / invalid result');
                                                return;
                                        }
                                    
                                    //  success
                                    //  =======
                                    
                                        //  sort
                                        //  ====
                                            _getResult.list.sort(function (a, b)
                                            {
                                                switch (true)
                                                {
                                                    case (a.name < b.name): return -1;
                                                    case (a.name > b.name): return 1;
                                                    default: return 0;
                                                }
                                            });
                                        
                                        //  return
                                        //  ======
                                            _onSuccess(_getResult.list);
                            },
                            $R.$remote.user__authToken);
                };
                
            
                //  get note link
                //      takes into account the setting "open_notes_in"
                //      if for business, uses business shard id, if not uses user shard id
                //      ads the authToken automatically
                
                $R.$remote.get_note_link = function (_for_business, _note_guid, _notebook_guid)
                {
                    var _authToken = (_for_business ? $R.$remote.business__authToken : $R.$remote.user__authToken),
                        _shardId = (_for_business ? $R.$remote.business__shardId : $R.$remote.user__shardId);
                    
                    switch (true)
                    {
                        case ($R.$remote.setting__open_notes_in == 'web'):
                        //  ==============================================
                        
                            switch (true)
                            {
                                case (!!_for_business):
                                    return $R.$remote.get_setAuthAndRedirect_link(''            +
                                        $R.$bootstrap.remote_domain                             +
                                        'shard/' +  _shardId + '/'                              +
                                        'business/dispatch/'                                    +
                                        'view/' + _note_guid                                    +
                                        '#st=b' + '&n=' + _note_guid + '&b=' + _notebook_guid   +
                                    '');
                                    break;
                                    
                                case (!_for_business):
                                    return $R.$remote.get_setAuthAndRedirect_link(''    +
                                        $R.$bootstrap.remote_domain                     +
                                        'shard/' +  _shardId + '/'                      +
                                        'view/' + _note_guid                            +
                                        '#st=p' + '&n=' + _note_guid                    +
                                    '');
                                    break;
                            }
                        
                            break;
                            
                        case ($R.$remote.setting__open_notes_in == 'desktop'):
                        //  ==================================================
            
                            switch (true)
                            {
                                case (!!_for_business):
                                    return ''                       +
                                        'evernote:///view/'         +
                                        $R.$remote.user__id + '/'   +
                                        _shardId + '/'              +
                                        _note_guid + '/'            +
                                        _note_guid + '/'            +
                                        _notebook_guid + '/'        +
                                        '?currentUSN=0'             +
                                    '';
                                    break;
                                    
                                case (!_for_business):
                                    return ''                       +
                                        'evernote:///view/'         +
                                        $R.$remote.user__id + '/'   +
                                        _shardId + '/'              +
                                        _note_guid + '/'            +
                                        _note_guid + '/'            +
                                        '?currentUSN=0'             +
                                    '';
                                    break;
                            }
                        
                            break;
                    }
                    
                    return '';
                };
                
                
                //  get SetAuthAndRedirect link
                //      if desktop client selected, will return the URL it was given
                //      to login on the web/client, before going to where we wnt to go
                
                $R.$remote.get_setAuthAndRedirect_link = function (_link)
                {
                    switch (true)
                    {
                        case ($R.$remote.setting__open_notes_in == 'web'):
                            return ''                                       +
                                $R.$bootstrap.remote_domain                 +
                                'SetAuthToken.action?auth=' + encodeURIComponent($R.$remote.user__authToken) +
                                '&targetUrl=' + encodeURIComponent(_link)   +
                            '';
                            break;
                            
                        case ($R.$remote.setting__open_notes_in == 'desktop'):
                            return _link;
                            break;
                    }
                    
                    return '';
                };
                
                
                //  get note thumbnail image
                //      will always get from the web
                //      will use the business auth token to get a business thumnbail
                
                $R.$remote.get_note_thumbnail = function (_for_business, _note_guid)
                {
                    var _authToken = (_for_business ? $R.$remote.business__authToken : $R.$remote.user__authToken),
                        _shardId = (_for_business ? $R.$remote.business__shardId : $R.$remote.user__shardId);
            
                    return ''                                       +
                        $R.$bootstrap.remote_domain                 +
                        'shard/' +  _shardId + '/'                  +
                        'thm/note/'                                 +
                        _note_guid                                  +
                        '?auth=' + encodeURIComponent(_authToken)   +
                        '&size=75'                                  +
                    '';
                };
                
        

        
        //  variable which holds what popup is currently open
        
            $R.$popup = {
                'which':    'string',           //  what popup is open -- currently 'login' is the only valid one
                'tab':      'integer||object',  //  what tab is the popup associated with -- tabId in Chrome, document object in Firefox
                'details':  'object'            //  popup specific details -- login has its own thing
            };
        
            //  none is the other valid variable
            $R.$popup = false;
        

        
        //  isolate
        //  =======
            (function ()
            {
                //  uage metrics
                //  ============
                    /* imported from the web-clipper */
                    /* init like this: if (!usageMetricsManager && auth) { usageMetricsManager = new UsageMetricsManager(url, isAuthenticated); } */
                    
                    // Takes a URL to make requests against, and a function that can be called to get back auth info. Currently, the spec
                    // for what should be passed to authFunction and what gets passed to authFunction's callback is exactly equivalent to
                    // Auth.isAuthenticated(), which is:
                    // Auth.isAuthenticated(callback, autoRenew)
                    //  callback: a function to call when we've decided whether a user is authenticated, this function will be passed an
                    //  object with the following properties:
                    //    username: the username used to perform the authentication (which can be an email address).
                    //    authenticationToken: the authentication token returned by a successful login on the server.
                    //    displayName: the username as it should be displayed in the UI (should not be an email address, may be the same as
                    //    username.  
                    //  NOTE: if authentication fails, NULL is passed to 'callback', not an object with null property values.
                    //
                    //  autoRenew: a boolean indicating whether the authFunction should attempt to automatically renew a stale auth token.
                    
                    function UsageMetricsManager(authFunction) {
                    
                      var usageMetrics = {};
                    
                      function recordActivity(_callback) {
                        var name = "";
                        function checkAuthCallback(auth)
                        {
                          // signed in/out
                          if (auth) {
                            name = auth.displayName;
                          }
                          else {
                            name = '__signed_out';
                          }
                          
                          // signed out
                          if (name == '__signed_out') {
                            var usage = usageMetrics[name];
                            if (!usage) {
                              usage = new UsageMetricsSignedOut();
                              usageMetrics[name] = usage;
                            }
                            usage.recordActivity(_callback);
                            return; // signed out, and done
                          }
                          
                          // signed in
                          if (name) {
                            var usage = usageMetrics[name];
                            if (!usage) {
                              usage = new UsageMetricsSignedIn(authFunction);
                              usageMetrics[name] = usage;
                            }
                            usage.recordActivity(_callback);
                          }
                        }
                        
                        authFunction(checkAuthCallback, true);
                      }
                    
                      this.recordActivity = recordActivity;
                    }
                    
                    /* imported from the web-clipper */
                    
                    // Each logged in user should get his own UsageMetrics object.
                    function UsageMetricsSignedIn(authFunction) {
                    
                      var INTERVAL_MINUTES = 15;
                    
                      // Timestamp of the 15 minute interval last sent to the server. We will not record events in this block or before.
                      var lastSent = 0;
                      var activityBlocks = {};
                    
                      // Gets the timestamp for the first second of the 15 minute block that we're currently in.
                      function getTimeBlock() {
                        var now = new Date();
                        var minutes = Math.floor(now.getMinutes() / INTERVAL_MINUTES) * INTERVAL_MINUTES;
                        now.setMinutes(minutes);
                        now.setSeconds(0);
                        now.setMilliseconds(0);
                        return Math.round(now.getTime() / 1000);
                      }
                    
                      function recordActivity(callback) {
                        var time = getTimeBlock();
                        if (lastSent >= time) {
                          if (callback) { callback(); }
                          return;
                        }
                        activityBlocks[time] = true;
                        send(callback);
                      }
                    
                      function send(callback) {
                        if (!navigator.onLine) {
                          if (callback) { callback(); }
                          return;
                        }
                        var count = 0;
                        var newLastSent = 0;
                        for (var i in activityBlocks) {
                          var num = parseInt(i, 2);
                          count++;
                          if (num > newLastSent) {
                            newLastSent = num;
                          }
                        }
                    
                        if (count > 0) {
                          sendRequest(count, newLastSent, callback);
                        }
                        else {
                          if (callback) { callback(); }
                        }
                      }
                    
                      function sendRequest(count, newLastSent, callback) {
                        function resultCallback(data, error) {
                          if (data) {
                            activityBlocks = [];
                            if (newLastSent > lastSent) {
                              lastSent = newLastSent;
                            }
                          }
                          if (callback) { callback(); }
                        }
                    
                        function sendCallback() {
                          $R.$remote.rpc__noteStore.NoteStore.getSyncStateWithMetrics(
                            resultCallback, 
                            $R.$remote.user__authToken, 
                            { 'sessions': count });
                        }
                    
                        function authCallback(_authInfo) {
                          if (_authInfo && _authInfo.authenticationToken){
                            sendCallback();
                          }
                          else {
                            //console.warn("Tried to send UsageMetrics, but not logged in.");
                            if (callback) { callback(); }
                          }
                        }
                    
                        authFunction(authCallback, true);
                      }
                      
                      function getJson() {
                        var json = {};
                        json.lastSent = lastSent;
                        json.activityBlocks = {};
                        // Deep copy.
                        for (var i in activityBlocks) {
                          json.activityBlocks[i] = activityBlocks[i];
                        }
                        return json;
                      }
                    
                      function importFromJson(json) {
                        try {
                          lastSent = json.lastSent;
                          activityBlocks = json.activityBlocks;
                        }
                        catch(e) {
                          lastSent = 0;
                          activityBlocks = {};
                          //console.warn("Failed to import saved UsageMetrics from JSON object.");
                        }
                      }
                    
                      this.recordActivity = recordActivity;
                      this.send = send;
                      this.getJson = getJson;
                      this.importFromJson = importFromJson;
                    }
                    
                    /* derived from UsageMetricsSignedIn */
                    
                    function UsageMetricsSignedOut() {
                      "use strict";
                    
                      var INTERVAL_MINUTES = 15;
                    
                      // Timestamp of the 15 minute interval last sent to the server. We will not record events in this block or before.
                      var lastSent = 0;
                      var activityBlocks = {};
                    
                      // Gets the timestamp for the first second of the 15 minute block that we're currently in.
                      function getTimeBlock() {
                        var now = new Date();
                        var minutes = Math.floor(now.getMinutes() / INTERVAL_MINUTES) * INTERVAL_MINUTES;
                        now.setMinutes(minutes);
                        now.setSeconds(0);
                        now.setMilliseconds(0);
                        return Math.round(now.getTime() / 1000);
                      }
                    
                      function recordActivity(callback) {
                        var time = getTimeBlock();
                        if (lastSent >= time) {
                          if (callback) { callback(); }
                          return;
                        }
                        activityBlocks[time] = true;
                        send(callback);
                      }
                    
                      function send(callback) {
                        if (!navigator.onLine) {
                          if (callback) { callback(); }
                          return;
                        }
                        var count = 0;
                        var newLastSent = 0;
                        for (var i in activityBlocks) {
                          var num = parseInt(i, 2);
                          count++;
                          if (num > newLastSent) {
                            newLastSent = num;
                          }
                        }
                    
                        if (count > 0) {
                          sendRequest(count, newLastSent, callback);
                        }
                        else {
                          if (callback) { callback(); }
                        }
                      }
                    
                      function sendRequest(count, newLastSent, callback) {
                        function resultCallback(data) {
                          if (data) {
                            activityBlocks = [];
                            if (newLastSent > lastSent) {
                              lastSent = newLastSent;
                            }
                          }
                          if (callback) { callback(); }
                        }
                    
                        function sendCallback()
                        {
                            //  get device id; set, if not present
                            var _device_id = $R.saved__get_device_id();
                        
                            //  create request
                            var _request = ''                           +
                                'a='  + encodeURIComponent('en-ff-clearly-xauth-new') +
                                '&d=' + encodeURIComponent(_device_id)  +
                                '&t=' + 'sessions'                      +
                                '&c=' + encodeURIComponent(count)       +
                                '&w=' + encodeURIComponent(Math.floor((new Date()).getTime()/1000)) +
                            '';
                                
                            //  signature
                            var _signature = $R.md5(_request + '8ad13eca201a80fa');
                            
                            //  sign request
                            _request = _request + '&g=' + encodeURIComponent(_signature);
                                
                            //  send request
                            $R.xhr('get', 'https://metrics.evernote.com/r?' + _request, function() { if (this.readyState == 4 && this.status == 200 && callback) { callback(); } });
                        }
                    
                        sendCallback();
                      }
                    
                      this.recordActivity = recordActivity;
                      this.send = send;
                    }
                    
        
                //  the metrics manager
                //  ===================
                    $R.session_tracking__usageMetricsManager = false;
                
                //  the high-level track function
                //  =============================
                    $R.session_tracking__track = function ()
                    {
                        //  not instantiated yet
                        //  ====================
                            if ($R.session_tracking__usageMetricsManager) {}else
                            {
                                $R.session_tracking__init(function () { $R.session_tracking__track(); });
                                return;
                            }
                    
                        //  do now
                        //  ======
                            $R.session_tracking__usageMetricsManager.recordActivity(function () { /* console.log('ran recordActivity'); */ });
                    };
                
                //  init metrics manager
                //  ====================
                    $R.session_tracking__init = function (_onSuccess)
                    {
                        $R.session_tracking__usageMetricsManager = new UsageMetricsManager($R.session_tracking__authFunction);
                        _onSuccess();
                    };
            
            
                //  auth function
                //  =============
                    $R.session_tracking__authFunction = function (_callback, _autoRenew)
                    {
                        //  doCallback
                        //  ==========
                            var _doCallback = function (_success)
                            {
                                //  failed
                                if (!_success) { _callback(false); return; }
                    
                                //  success
                                _callback({ 
                                    'authenticationToken':  $R.$remote.user__authToken,
                                    'displayName':          $R.$remote.user__id,
                                    'username':             $R.$remote.user__id
                                }); 
                            };
                    
                        //  not logged in
                        //  =============
                            switch (true)
                            {
                                case (!($R.$remote.is__connected)):
                                case (!($R.$remote.is__loggedIn)):
                                case (!($R.$remote.is__notExpired())):
                            
                                    //  don't auto renew -- just fail
                                    if (_autoRenew) {}else { _doCallback(false); return; }
        
                                    //  get login
                                    var _storedLogin = $R.credentials__get();
                            
                                    //  do stored login
                                    $R.$remote.loginWithAuthToken(
                                        _storedLogin.xAuthToken,
        
                                        //    success | login
                                        function () { _doCallback(true); return; },
        
                                        //    failure | login
                                        function (_failReason) { _doCallback(false); return; });
                            
                                    return;
                                    break;
                            }
                                
                        //  logged in -- do callback
                        //  =========
                            _doCallback(true);
                    };
            })();
            
        
        //  google analytics -- docs: https://developers.google.com/analytics/devguides/collection/protocol/v1/devguide
        //  ================
        
            $R.analytics__track_event = function (_category, _action, _label)
            {
                //  data to be sent
                var _data =     { 'type': 'event' };
                if (_category)  { _data['category'] = _category; }
                if (_action)    { _data['action'] = _action; }
                if (_label)     { _data['label'] = _label; }
        
                //  category and action are required        
                if (_category && _action) {}else { return false; }
        
                //  send
                $R.analytics__send(_data);
                
                //  good
                return true;
            };
        
            $R.analytics__send = function (_data)
            {
                //  add metadata
                //  ============
                
                    _data['property_id'] =  'UA-285778-79'; /* live; previous: 'UA-28770131-1'; test: 'UA-28238478-1'; */
                    _data['client_id'] =    $R.saved__get_device_id();
                
                    _data['app_name'] =     'Clearly';
                    _data['app_version'] =  '10.2.1.7';
        
                    _data['api_version'] =  '1';
        
        
                //  post
                //  ====
                
                    //  actual GA parameter names -- they're very very short
                    var _parameter_names = {
                        'api_version':  'v',
                        'property_id':  'tid',
                        'client_id':    'cid',
                
                        'app_name':     'an',
                        'app_version':  'av',
                
                        'type':         't',
                
                        'category':     'ec',
                        'action':       'ea',
                        'label':        'el'
                    };
        
                    //  data to send
                    var _data2 = {};
                    for (var _key in _data) { _data2[_parameter_names[_key]] = _data[_key]; }
        
                    //  send -- also does the encoding of _data2
                    $R.xhr('POST', 'https://ssl.google-analytics.com/collect', false, _data2);
            };
        
        
        
        //  first show
        //  ==========
            $R.first__show = function()
            {
                //  already done -- somehow
                //  ============
                    if ($R.firstShow) { return; }
        
                //  check if not first run
                //  ======================
                    if ($R.storage__get('notFirstRun') != 'yes') 
                    {
                        $R.firstShow = 'all-features';
                        return;
                    }
                    else
                    {
                        if ($R.storage__get('firstShowIdentifier') == $R.first_show_identifier) {}else
                        {
                            $R.firstShow = 'new-features';
                            return;
                        }
                    }
            };
        
        
        //  first run
        //  =========
            $R.first__run = function()
            {
                //  check -- maybe return
                //  =====
                    if ($R.storage__get('notFirstRun') == 'yes') { return; }
        
                //  set
                //  ===
                    $R.storage__set('notFirstRun', 'yes');
                
                //  add button -- just for firefox
                //  ==========
                     $R.putButtonInToolbar("nav-bar", "readable_by_evernote__button");
                
                
                //  open info url
                //  =============
                    var defaultInfoURL = 'http://www.evernote.com/clearly/guide/';
                    $R.$bootstrap.bootstrap(
                        function ()
                        {
                            var url = '';
                                url = (url > '' ? url : $R.$bootstrap.remote_domain_marketing);
                                url = (url > '' ? url + 'clearly/guide/' : defaultInfoURL);
        
                            $R.open_url_in_new_tab(url);
                        },
                        function ()
                        {
                            $R.open_url_in_new_tab(defaultInfoURL);
                        });
            };
        
        
        //  defaults -- if options/vars not set
        //  ========
            $R.assure_defaults = function ()
            {
                for (var _x in $R.default_options)
                {
                    var _valueDefault = $R.default_options[_x],
                        _valueNow = $R.storage__get(_x);
        
                    switch (true)
                    {
                        case (!(_valueNow > '')):
                        case ((_valueNow == '--def--')):
                            $R.storage__set(_x, $R.encode(_valueDefault));
                            break;
                    }
                }
                    
                for (var _x in $R.default_vars)
                {
                    var _valueDefault = $R.default_vars[_x],
                        _valueNow = $R.storage__get(_x);
        
                    switch (true)
                    {
                        case (!(_valueNow > '')):
                        case ((_valueNow == '--def--')):
                            $R.storage__set(_x, $R.encode(_valueDefault));
                            break;
                    }
                }
            };
        
        
    })(window.__readable_by_evernote);


//  firefox-specific imports from _js_anywhere/ -- in chrome, these are in content.js
//  ===========================================

    (function ($R) {
    
        (function () {
            
            //  var
            //  ===
                var _custom_events = false;
            
            //  code
            //  ====
                (function ()
                {
                
                    var _names_to_keys = {},
                        _keys_to_names = {},
                        _names_to_objects = {},
                        _custom_events_list = [
                    
                            ['to-extension--open--settings',                                  'click-111-111-111-111-1-1-1'],
                            ['to-extension--open--settings--theme',                           'click-112-112-112-112-1-1-1'],
                            ['to-extension--open--settings--speech',                          'click-113-113-113-113-1-1-1'],
                        
                            ['to-extension--open--premium',                                   'click-114-114-114-114-1-1-1'],
                            ['to-extension--open--two-factor-help',                           'click-115-115-115-115-1-1-1'],
                            ['to-extension--open--password-reset',                            'click-116-116-116-116-1-1-1'],
            
                            /* === */
            
                            ['to-extension--select--theme--theme-1',                          'click-121-121-121-121-1-1-1'],
                            ['to-extension--select--theme--theme-2',                          'click-122-122-122-122-1-1-1'],
                            ['to-extension--select--theme--theme-3',                          'click-123-123-123-123-1-1-1'],
                            ['to-extension--select--theme--custom',                           'click-124-124-124-124-1-1-1'],
            
                            ['to-extension--select--size--small',                             'click-125-125-125-125-1-1-1'],
                            ['to-extension--select--size--medium',                            'click-126-126-126-126-1-1-1'],
                            ['to-extension--select--size--large',                             'click-127-127-127-127-1-1-1'],
            
                            ['to-extension--select--related-notes--just-at-bottom',           'click-128-128-128-128-1-1-1'],
                            ['to-extension--select--related-notes--disabled',                 'click-129-129-129-129-1-1-1'],
            
                            /* === */
                        
                            ['to-extension--track--clip',                                     'click-132-132-132-132-1-1-1'],
                            ['to-extension--track--view',                                     'click-131-131-131-131-1-1-1'],
                            ['to-extension--track--theme-popup',                              'click-133-133-133-133-1-1-1'],
                            ['to-extension--track--settings',                                 'click-134-134-134-134-1-1-1'],
                            ['to-extension--track--speech-start',                             'click-135-135-135-135-1-1-1'],
            
                            ['to-extension--track--first-show--check',                        'click-136-136-136-136-1-1-1'],
                            ['to-extension--track--first-show--mark',                         'click-137-137-137-137-1-1-1'],
                        
                            /* === */
                        
                            ['to-extension--evernote--clip',                                  'click-141-141-141-141-1-1-1'],
                            ['to-extension--evernote--clip-highlights',                       'click-142-142-142-142-1-1-1'],
            
                            ['to-extension--evernote--get-recommendation',                    'click-143-143-143-143-1-1-1'],
            
                            ['to-extension--evernote--speech-start',                          'click-144-144-144-144-1-1-1'],
                            ['to-extension--evernote--speech-show-login',                     'click-145-145-145-145-1-1-1'],
            
                         /* ['to-extension--evernote--get-user',                              'click-145-145-145-145-1-1-1'], */
                         /* ['to-extension--evernote--unset-tag',                             'click-146-146-146-146-1-1-1'], */
                         /* ['to-extension--evernote--unset-notebook',                        'click-147-147-147-147-1-1-1'], */
                        
                            ['to-extension--evernote--login--do',                             'click-151-151-151-151-1-1-1'],
                            ['to-extension--evernote--login--do-second-factor',               'click-152-152-152-152-1-1-1'],
                            ['to-extension--evernote--login--switch-to-cn',                   'click-154-154-154-154-1-1-1'],
                            ['to-extension--evernote--login--switch-to-in',                   'click-155-155-155-155-1-1-1'],
                            ['to-extension--evernote--login--now-open',                       'click-156-156-156-156-1-1-1'],
            
                         /* ['to-extension--evernote--login--request-load--from-outside',     'click-153-153-153-153-1-1-1'], */
                        
                         /* ['to-extension--evernote--register--do',                          'click-161-161-161-161-1-1-1'], */
                         /* ['to-extension--evernote--register--request-load--from-outside',  'click-162-162-162-162-1-1-1'], */
                         /* ['to-extension--evernote--register--switch-to-cn',                'click-164-164-164-164-1-1-1'], */
                         /* ['to-extension--evernote--register--switch-to-in',                'click-165-165-165-165-1-1-1'], */
                        
                            /* ========================================================================================= */
                        
                            ['to-browser--evernote--login--show',                             'click-211-211-211-211-1-1-1'],
                            ['to-browser--evernote--login--show--in',                         'click-211-212-212-212-1-1-1'],
                            ['to-browser--evernote--login--show--in-cn',                      'click-211-213-213-213-1-1-1'],
                            ['to-browser--evernote--login--show--cn',                         'click-211-214-214-214-1-1-1'],
                            ['to-browser--evernote--login--show--cn-in',                      'click-211-215-215-215-1-1-1'],
            
                            ['to-browser--evernote--login--successful',                       'click-212-212-212-212-1-1-1'],
                            ['to-browser--evernote--login--now-open',                         'click-213-213-213-213-1-1-1'],
                        
                            /* === */
            
                            ['to-browser--evernote--login--set--in',                          'click-214-214-214-214-1-1-1'],
                            ['to-browser--evernote--login--set--in-cn',                       'click-215-215-215-215-1-1-1'],
                            ['to-browser--evernote--login--set--cn',                          'click-216-216-216-216-1-1-1'],
                            ['to-browser--evernote--login--set--cn-in',                       'click-217-217-217-217-1-1-1'],
            
                            ['to-browser--evernote--login--request-second-factor',            'click-221-221-221-221-1-1-1'],
            
                            ['to-browser--evernote--login--failed',                           'click-222-222-222-222-1-1-1'],
                            ['to-browser--evernote--login--failed--username',                 'click-223-223-223-223-1-1-1'],
                            ['to-browser--evernote--login--failed--password',                 'click-224-224-224-224-1-1-1'],
                            ['to-browser--evernote--login--failed--password-reset',           'click-225-225-225-225-1-1-1'],
            
                            ['to-browser--evernote--login--failed--two-factor--code',         'click-226-226-226-226-1-1-1'],
                            ['to-browser--evernote--login--failed--two-factor--timeout',      'click-227-227-227-227-1-1-1'],
            
                         /* ['to-browser--evernote--login--show--in-frame',                   'click-212-212-212-212-1-1-1'], */
            
                            /* === */
                        
                         /* ['to-browser--evernote--register--show',                          'click-231-231-231-231-1-1-1'], */
                         /* ['to-browser--evernote--register--show--in-frame',                'click-232-232-232-232-1-1-1'], */
            
                         /* ['to-browser--evernote--register--set--in',                       'click-234-234-234-234-1-1-1'], */
                         /* ['to-browser--evernote--register--set--in-cn',                    'click-235-235-235-235-1-1-1'], */
                         /* ['to-browser--evernote--register--set--cn',                       'click-236-236-236-236-1-1-1'], */
                         /* ['to-browser--evernote--register--set--cn-in',                    'click-237-237-237-237-1-1-1'], */
            
                         /* ['to-browser--evernote--register--successful',                    'click-241-241-241-241-1-1-1'], */
                         /* ['to-browser--evernote--register--failed',                        'click-242-242-242-242-1-1-1'], */
                        
                            /* === */
            
                            ['to-browser--evernote--speech--go',                              'click-257-257-257-257-1-1-1'],
            
                            ['to-browser--evernote--clip--successful',                        'click-251-251-251-251-1-1-1'],
                            ['to-browser--evernote--clip--failed',                            'click-252-252-252-252-1-1-1'],
            
                            ['to-browser--evernote--clip-highlights--successful',             'click-253-253-253-253-1-1-1'],
                            ['to-browser--evernote--clip-highlights--failed',                 'click-254-254-254-254-1-1-1'],
            
                            ['to-browser--evernote--get-recommendation--successful',          'click-255-255-255-255-1-1-1'],
                            ['to-browser--evernote--get-recommendation--failed',              'click-256-256-256-256-1-1-1'],
                        
                            /* === */
                        
                            ['to-browser--show--dialog-first--all-features',                  'click-261-261-261-261-1-1-1'],
                            ['to-browser--show--dialog-first--new-features',                  'click-262-262-262-262-1-1-1'],
                        
                            ['to-browser--show--dialog-speech--need-login',                   'click-263-263-263-263-1-1-1'],
                            ['to-browser--show--dialog-speech--need-premium',                 'click-264-264-264-264-1-1-1']
                        
                        ];
                
                     /* Explanations for some of the to-extension events:
                     // =================================================
                        to-extension--evernote--login--do:
                            triggered by:   frame -- when button is pressed
                            operates in:    background, frame -- gets the username/password from the frame, and performs a background login
                            triggers:       browser...login--successful/failed/failed--username/failed--password/failed--password-reset
            
                        to-extension--evernote--login--do-second-factor:
                            triggered by:   frame -- when button is pressed, in the "enter code" view
                            operates in:    background, frame -- gets the code from the frame, and performs a background completeLogin
                            triggers:       browser...login--successful/failed--second-factor/failed--second-factor-timeout
            
                        to-extension--evernote--login--request-load--from-outside:
                            triggered by:   html -- after clearly has launched; firefox only
                            operates in:    background -- forces the loading of the url into the frame; and then loads everything else too
                        
                        to-extension--evernote--login--switch-to-cn/in:
                            triggered by:   frame -- when user clicks on china/international toggle
                            operates in:    background -- switches the background china-mode on/off
                            triggers:       browser...login--set--in/in-cn/cn/cn-in
                     */   
                
                     /* Explanations for some of the to-browser events:
                     // ===============================================
                        to-browser--evernote--login--show:
                            triggered by:   background -- when it detects that login is needed; should be triggered after login-show--in-frame
                            operates in:    html -- shows the login dialog
            
                        to-browser--evernote--login--show--in-frame:
                            triggered by:   background -- when it detects that login is needed; should be triggered before login-show
                            operates in:    frame -- does stuff inside the login frame; like, for example, clear the errors from last time
            
                        to-browser--evernote--login--request-second-factor:
                            triggered by:   background -- when it detects that second factor is needed
                            operates in:    frame -- does stuff inside the login frame: shows the second-factor view
                            
                        to-browser--evernote--login--set--in/in-cn/cn/cn-in:
                            triggered by:   background -- after a request has been sent from the frame, the background performs switch, and responds with this event
                            operates in:    frame -- switches around the on/off toggles for china/international
                            
                        to-browser--evernote--login--failed/failed--username/failed--password
                            triggered by:   background -- after the login button was pressed in the frame, it sent an event to the background, which tried to login with the supplied details; the background is now responding with this event
                            operates in:    frame -- frame will display the error
            
                        to-browser--evernote--login--failed--password-reset/two-factor
                            triggered by:   background -- after the login button was pressed in the frame, it sent an event to the background, which tried to login with the supplied details; the background is now responding with this event
                            operates in:    html -- display error dialog for password reset
                            
                        to-browser--evernote--login--successful:
                            triggered by:   background; same as above
                            operates in:    html -- will hide the login dialog, and continue performing whatever operation is was trying to do before
                     */
            
                    
                    //  fill in event objects
                    //  =====================
                        for (var i=0,_i=_custom_events_list.length,e=false,k=false; i<_i; i++)
                        {
                            e = _custom_events_list[i];
                            k = e[1].split('-');
                    
                            _names_to_keys[e[0]] = e[1];
                            _keys_to_names[e[1]] = e[0];
                            _names_to_objects[e[0]] = {
                                '_1': k[1],
                                '_2': k[2],
                                '_3': k[3],
                                '_4': k[4],
                                '_5': (k[5] == 1 ? true : false),
                                '_6': (k[6] == 1 ? true : false),
                                '_7': (k[7] == 1 ? true : false)
                            };
                        }
                    
                    
                    //  define _get_gey function
                    //  ========================
                        var _get_key = function (_event)
                        {
                            return ''                           +
                                'click'                         +
                                '-'+_event.screenX              +
                                '-'+_event.screenY              +
                                '-'+_event.clientX              +
                                '-'+_event.clientY              +
                                '-'+(_event.ctrlKey ?   1 : 0)  +
                                '-'+(_event.altKey ?    1 : 0)  +
                                '-'+(_event.shiftKey ?  1 : 0)  +
                            '';
                        };
                
                
                    //  define _dispatch function
                    //  =========================
                        var _dispatch = function (_custom_event_object, _window)
                        {
                            var _d = _window.document,
                                _e = _d.createEvent("MouseEvents");
                    
                            _e.initMouseEvent(
                                "click", true, true, _window, 0, 
                                _custom_event_object['_1'], 
                                _custom_event_object['_2'], 
                                _custom_event_object['_3'], 
                                _custom_event_object['_4'], 
                                _custom_event_object['_5'], 
                                _custom_event_object['_6'], 
                                _custom_event_object['_7'], 
                                false, 0, null);
                    
                            _d.dispatchEvent(_e);
                        };
                
                
                    //  define custom events object
                    //  ===========================
                        _custom_events = {
                            'names_to_keys':    _names_to_keys,
                            'keys_to_names':    _keys_to_names,
                            'names_to_objects': _names_to_objects,
                            
                            'get_key':          _get_key,
                            'dispatch':         _dispatch
                        };
                    
                    
                    //  return
                        return;
                        
                })();
            
            /* =============== */
            $R.custom_events = _custom_events;
        })();

        (function () {
            
            //  get key combo
            //  =============    
                var _get_key_combo_from_event = function (_event)
                {
                    //  _event can be a browser event or a jQuery event
                    
                    var _key_code = 'NONE';
                    switch (true)
                    {
                        case (_event.keyCode && (_event.keyCode >= 65 && _event.keyCode <= 90)):
                            _key_code = String.fromCharCode(_event.keyCode).toUpperCase();
                            break;
                        
                        case (_event.keyCode == 27):    _key_code = 'Escape';        break;
                        case (_event.keyCode == 37):    _key_code = 'Left Arrow';    break;
                        case (_event.keyCode == 39):    _key_code = 'Right Arrow';   break;
                        case (_event.keyCode == 38):    _key_code = 'Up Arrow';      break;
                        case (_event.keyCode == 40):    _key_code = 'Down Arrow';    break;
                    }
            
                    var _modifierKeys = (_event.originalEvent ? _event.originalEvent : _event);
                    //  jQuery screws up -- fucks up the metaKey property badly
                    
                    var _key_combo = ''                                 +
                        (_modifierKeys.ctrlKey ?    'Control + ' : '')  +
                        (_modifierKeys.shiftKey ?   'Shift + ' : '')    +
                        (_modifierKeys.altKey ?     'Alt + ' : '')      +
                        (_modifierKeys.metaKey ?    'Command + ' : '')  +
                        _key_code                                       +
                    '';
            
                    if ((_key_code != 'Escape') && (_key_code == _key_combo))
                    {
                        _key_code = 'NONE';
                        _key_combo = 'NONE';
                    }
                    
                    //  return
                    return {
                        '_key_code': _key_code,
                        '_key_combo': _key_combo
                    };
                };
                
            /* =============== */
            $R.get_key_combo_from_event = _get_key_combo_from_event;
        })();

    })(window.__readable_by_evernote);


//  firefox-specific imports from _js_in_background/_anywhere/ -- in chrome, these are in content.js
//  ==========================================================
    (function ($R) {

        (function () {
            
            //  get html to clip
            //  ================
                var _get_html_to_clip = function (_doc)
                {
                    //  import components/highlight -> getCleanHTML
                    //  ===========================================
                    
                        //  object
                        var $H = {};
                    
                        //  settings
                        $H.settings = {};
                        $H.settings.highlightElementCSSClass =        'clearly_highlight_element';
                        $H.settings.highlightElementDeleteCSSClass =  'clearly_highlight_delete_element';
                        $H.settings.highlightCleanHTMLElementStart =  '<span style="-evernote-highlighted:true; background-color:#f6ee96">';
                        $H.settings.highlightCleanHTMLElementEnd =    '</span>';
                    
                        //  clean html
                        $H.getCleanHTML = function (_rawHTML)
                        {
                            //  html
                            var _html = _rawHTML;
                
                            //  remove all spans -- spans hold deleted highlights, or useless helper elements
                            _html = _html.replace(/<span([^>]*?)>/gi, '');
                            _html = _html.replace(/<\/span>/gi, '');
            
                            //  remove highlight-delete buttons
                            var _highlight_delete_reg = new RegExp('<a ([^>]*?)'+$H.settings.highlightElementDeleteCSSClass+'([^>]*?)></a>', 'gi');
                            _html = _html.replace(_highlight_delete_reg, '');
            
                            //  highlight element
                            var _highlight_element_reg = new RegExp('<em ([^>]*?)'+$H.settings.highlightElementCSSClass+'([^>]*?)>([^>]+?)</em>', 'gi');
                            _html = _html.replace(_highlight_element_reg, '<highlight>$3</highlight>');
            
                            //  double EMs
                            var _two_highlights_reg = new RegExp('<highlight>([\\s\\S]*?)</highlight>([ \\n\\r\\t]*?)<highlight>([\\s\\S]*?)</highlight>', 'gi');
                            while (true && (_html.match(_two_highlights_reg) != null)) {
                                _html = _html.replace(_two_highlights_reg, '<highlight>$1$3</highlight>');
                            }
            
                            //  replace EMs
                            var _highlight_reg = new RegExp('<highlight>([\\s\\S]*?)</highlight>', 'gi');
                            _html = _html.replace(_highlight_reg, $H.settings.highlightCleanHTMLElementStart+'$1'+$H.settings.highlightCleanHTMLElementEnd);
                
                            return _html;
                        };
            
                
                    //  get html
                    //  ========
                    
                        //  get all "page_content" child elements 
                        //      of all "page" elements 
                        //          of the "#pages" element
                        //  add #footnotedLinks ol element?
            
                        var _pages_container = _doc.getElementById('pages');
                        var _pages_container_dir = (_pages_container.getAttribute ? ('' + _pages_container.getAttribute('dir')).toLowerCase() : '');
                
                        //  var
                        var __body = '';
            
                        //  add #pages start
                        __body += '<div id="pages"'+(_pages_container_dir == 'rtl' ? ' dir="rtl"' : '')+'>';
                    
                        //  loop through pages
                        var _pages = _pages_container.childNodes;
                        for (var _i=0, _ii=_pages.length; _i<_ii; _i++)
                        {
                            var _page_elements = _pages[_i].childNodes;
                            for (var _z=0, _zz=_page_elements.length; _z<_zz; _z++)
                            {
                                //  element
                                var _page_element = _page_elements[_z];
                                
                                //  not page_content
                                if (_page_element.className && _page_element.className.toLowerCase && _page_element.className.toLowerCase() == 'page_content') {}else { continue; }
                                
                                //  append content
                                __body += '<div id="page'+(_i+1)+'" class="page">';
                                __body +=   _page_element.innerHTML;
                                __body += '</div>';
                                
                                //  one per page
                                break;
                            }
                        }
                    
                        //  add #pages end
                        __body += '</div>';
            
                    
                    //  clean highlights
                    //  ================
                        __body = $H.getCleanHTML(__body);
                    
                    
                    //  remove link footnotes
                    //  =====================
                        __body = __body.replace(/<sup class="readableLinkFootnote">([^<]*)<\/sup>/gi, '');
            
            
                    //  return
                    //  ======
                        return __body;
                };
            
            /* =============== */
            $R.get_html_to_clip = _get_html_to_clip;
        })();

        (function () {
            
            //  inject
            //  ======    
                var _inject_recommendation = function (_filingRecommendation, _documentToInjectInto, _escape_html_function)
                {
                    //  injected
                    var _injected_element = _documentToInjectInto.getElementById('relatedNotes__injected');
                        
                    //  check
                    if (_injected_element.innerHTML == 'yup') { return; }
                        
                    //  set
                    _injected_element.innerHTML = 'yup';
                           
                    //  notes & inject
                    //  ==============
                        var _notes = [],
                            _injectNote = function (_html_id, _note_index)
                            {
                                var _element = _documentToInjectInto.getElementById(_html_id), _data = _notes[_note_index];
                                
                                //  invalid
                                if (_element && _data) {}else { return; }
            
                                //  thumbnail
                                var _thumbnail = _data.absoluteURL__thumbnail;
                                
                                //  thumbnail retina
                                if (true && (_documentToInjectInto.defaultView) && (_documentToInjectInto.defaultView.devicePixelRatio) && (_documentToInjectInto.defaultView.devicePixelRatio == 2)) { _thumbnail = _thumbnail.replace(/size=75$/, 'size=150'); }
                                
                                //  write
                                _element.innerHTML = ''     +
                                    '<div class="text">'    +
                                        '<a target="_blank" href="'+_escape_html_function(_data.absoluteURL__noteView)+'" class="title">'+_escape_html_function(_data.title)+'</a>' +
                                        '<a target="_blank" href="'+_escape_html_function(_data.absoluteURL__noteView)+'" class="snippet">'+_escape_html_function(_data.snippet)+'</a>' +
                                        '<a target="_blank" href="'+_escape_html_function(_data.absoluteURL__noteView)+'" class="img" style="' + (_thumbnail == 'none' ? '' : 'background-image: url(\''+_escape_html_function(_thumbnail)+'\');') + '"></a>' +
                                    '</div>'                +
                                '';
                                //  '<a target="_blank" href="'+_escape_html_function(_data.absoluteURL__noteView)+'" class="date">'+_escape_html_function(((new Date(_data.created)).toDateString()))+'</a>'
                                
                                //  Evernote links -- remove target
                                var _links = _element.getElementsByTagName('a');
                                for (var i=0, _i=_links.length; i<_i; i++) { if (_links[i].getAttribute('href').match(/^evernote:\/\/\//gi) != null) { _links[i].setAttribute('target', ''); } }
                            };
                        
                    //  which notes
                    //  ===========
                        var _hasNotes = false, _hasBusinessNotes = false;
                        
                        //  personal
                        if (true && _filingRecommendation.relatedNotes && _filingRecommendation.relatedNotes.list && _filingRecommendation.relatedNotes.list.length && _filingRecommendation.relatedNotes.list.length > 0) { _hasNotes = true; }
                        
                        //  business
                        if (true && _filingRecommendation.businessRecommendation && _filingRecommendation.businessRecommendation.relatedNotes && _filingRecommendation.businessRecommendation.relatedNotes.list && _filingRecommendation.businessRecommendation.relatedNotes.list.length && _filingRecommendation.businessRecommendation.relatedNotes.list.length > 0) { _hasBusinessNotes = true; }
            
                        //  cases
                        switch (true)
                        {
                            case (_hasNotes && _hasBusinessNotes):
                                _notes = [
                                    _filingRecommendation.relatedNotes.list[0],
                                    _filingRecommendation.businessRecommendation.relatedNotes.list[0]
                                ];
                                break;
                                
                            case (_hasNotes && !_hasBusinessNotes):
                                _notes = _filingRecommendation.relatedNotes.list;
                                break;
                                
                            case (_hasBusinessNotes && !_hasNotes):
                                _notes = _filingRecommendation.businessRecommendation.relatedNotes.list;
                                break;
                        }
                            
                    //  actually inject
                    //  ===============
                        if (_notes.length > 0)
                        {
                            //  show
                            var _notesElement = _documentToInjectInto.getElementById('relatedNotes');
                            if (_notesElement) { _notesElement.className = 'none'; }
                            
                            //  need to be in this order
                            _injectNote('relatedNotes__first', 0);
                            _injectNote('relatedNotes__second', 1);
                        }
                };
            
            /* =============== */
            $R.inject_recommendation = _inject_recommendation;
        })();

        (function () {
            
            //  inject
            //  ======
                var _inject_filing_info = function (_filingInfo, _documentToInjectInto, _escape_html_function)
                {
                    //  injected
                    var _injected_element = _documentToInjectInto.getElementById('filingInfo_injected');
                            
                    //  check
                    if (_injected_element.innerHTML == 'yup') { return; }
                            
                    //  set
                    _injected_element.innerHTML = 'yup';
                
                    //  notebook
                    //  ========
                        var _notebook_name = (_filingInfo.notebook_name);
                            _notebook_name = (_notebook_name > '' ? _notebook_name : _documentToInjectInto.getElementById('filingInfo_notebook_default').innerHTML);
                        _documentToInjectInto.getElementById('filingInfo_notebook').innerHTML = _escape_html_function(_notebook_name);
            
                    //  tags
                    //  ====
                        var _tags_element = _documentToInjectInto.getElementById('filingInfo_tags');
                        for (var _s=false, i=0, _i=_filingInfo.tag_names.length; i<_i; i++)
                        {
                            _s = _documentToInjectInto.createElement('span');
                            _s.innerHTML = _escape_html_function(_filingInfo.tag_names[i]);
                            _tags_element.appendChild(_s);
                        }
                        
                    //  links
                    //  =====
                        
                        //  add URLs
                        var _links = _documentToInjectInto.getElementById('filingInfo_links');
                            _links.innerHTML = _links.innerHTML.replace('#url-edit', _filingInfo.url_edit);
                          //_links.innerHTML = _links.innerHTML.replace('#url-view', _filingInfo.url_view);
                          
                        //  Evernote links -- remove target
                        var _links2 = _links.getElementsByTagName('a');
                        for (var i=0, _i=_links2.length; i<_i; i++) { if (_links2[i].getAttribute('href').match(/^evernote:\/\/\//gi) != null) { _links2[i].setAttribute('target', ''); } }
                };
                
            /* =============== */
            $R.inject_filing_info = _inject_filing_info;
        })();

        (function () {
            
            //  launcher
            //  ========
                var _inject_launcher = function (__document, __script_to_launch, __definitions_as_html)
                {
                    //  IDs
                    var _id__container =         'evernote_clearly__container',
                        _id__definitions =       'evernote_clearly__definitions',
                        _id__launcher =          'evernote_clearly__launcher',
                        _id__css_for_container = 'evernote_clearly__css_for_container';
            
                    //  log
                    var _log = function (_message) { if (console && console.log) { console.log('evernote_clearly / inject_launcher / ' + _message); } };
            
                    //  need body; else stop
                    var _body = __document.getElementsByTagName('body')[0];
                    if (_body) {}else { _log('page is missing body element'); return; }
                    
                    //  vars
                    var _container = __document.getElementById(_id__container),
                        _definitions = __document.getElementById(_id__definitions), 
                        _launcher = __document.createElement('script');
            
                    //  define launcher
                    _launcher.setAttribute('src', __script_to_launch);
                    _launcher.className = _id__launcher;
            
                    //  create container, if not present -- and css for container
                    if (_container) {}else
                    {
                        //  controller container
                        var _containerElement = __document.createElement('div');
                            _containerElement.setAttribute('id', _id__container);
            
                        //  container css
                        var _cssText = ''                                                   +
                             '#'+_id__container+' { '                                   +
                                 'position: absolute !important; '                      +
                                 'width: 5px !important; height: 5px !important; '      +
                                 'top: -1000px !important; left: -1000px !important; '  +
                                 'margin: 0 !important; padding: 0 !important; border: none !important; ' +
                            '} '                                                        +
                            '#'+_id__definitions+' { display: none !important; } '      +
                        '';
                        _cssText = _cssText.replace(/\} /gi, "} \n");
            
                        var _cssElement = __document.createElement('style');
                            _cssElement.setAttribute('id', _id__css_for_container);
                            _cssElement.setAttribute('type', 'text/css');
                        if (_cssElement.styleSheet) { _cssElement.styleSheet.cssText = _cssText; }
                            else { _cssElement.appendChild(__document.createTextNode(_cssText)); }
            
                        //  append container
                        _body.appendChild(_containerElement);
            
                        //  get container (again)        
                        _container = __document.getElementById(_id__container);
            
                        //  append css
                        _container.appendChild(_cssElement);
                    }
            
                    //  create definitions, if not present
                    if (_definitions) {}else
                    {
                        var _definitionsElement = __document.createElement('div');
                            _definitionsElement.setAttribute('id', _id__definitions);
            
                        //  append definitions
                        _container.appendChild(_definitionsElement);
                        
                        //  get definitions (again)        
                        _definitions = __document.getElementById(_id__definitions);
                    }
            
                    //  (re)set definitions
                    _definitions.innerHTML = __definitions_as_html;
            
                    //  insert launcher -- inserting several launchers does nothing bad
                    _container.appendChild(_launcher);
                };
            
            /* =============== */
            $R.inject_launcher = _inject_launcher;
        })();

        (function () {
            
            //  add keyboard hook
            //  =================
                var _add_keyboard_hook = function (__window, __keys, __get_key_combo_from_event, __inject)
                {
                    __window.addEventListener('keydown', function(_event)
                    {
                        var _key_combo_from_event = __get_key_combo_from_event(_event),
                            _key_combo =            _key_combo_from_event._key_combo;
            
                        switch (true)
                        {
                            case ((__keys._key_activation > '')   && (_key_combo == __keys._key_activation)):
                            case ((__keys._key_clip > '')         && (_key_combo == __keys._key_clip)):
                            case ((__keys._key_highlight > '')    && (_key_combo == __keys._key_highlight)):
            
                        
                                
                                //  also?
                                var _clip_on_launch =       ((__keys._key_clip > '')         && (_key_combo == __keys._key_clip)),
                                    _highlight_on_launch =  ((__keys._key_highlight > '')    && (_key_combo == __keys._key_highlight));
                        
                                    
                                //  visible already; ignore
                                var _doc = (__window.contentDocument || __window.document);
                                var _body = _doc.getElementsByTagName('body')[0];
                                if (_body && _body.className && (_body.className.match(/evernote_clearly__is_visible/) != null)) { break; }
                                    
                                //  stop event
                                _event.stopPropagation();
                                _event.preventDefault();
            
                                //  inject
                                __inject(_doc, _clip_on_launch, _highlight_on_launch, _speech_on_launch);
                                
                                //  end
                                break;
                            }
                        
                        }, true);
                };
            
            /* =============== */
            $R.add_keyboard_hook = _add_keyboard_hook;
        })();

        (function () {
            
            //  expose
            //  ======
                var _expose_as_installed = function (_window)
                {
                    //  this allows evernote controlled websites to detect when clearly is installed
                    //  this code tries to add a meta element to the head of the page, and a class to the body of the page
            
                    //  only on evernote domains
                    //  ========================
                        if (_window.location.hostname.match(/(evernote|yinxiang).com$/gi) != null) {}else { return; }
                    
                    //  try to add meta element to page-head
                    //  ====================================
                        try
                        {
                            var _meta = _window.document.createElement("meta");
                                _meta.name = "evernote-clearly-extension";
                                _meta.content = "installed";
                        
                            _window.document.head.appendChild(_meta);
                        }
                        catch (e) {}
                    
                    //  try to add class to page-body
                    //  =============================
                        try { _window.document.body.className += ' evernote-clearly-extension'; }
                        catch (e) {}
                };
                
            /* =============== */
            $R.expose_as_installed = _expose_as_installed;
        })();

        (function () {
            
            //  serialize object as html
            //  ========================
                var _serialize_object_as_custom_html = function (_stuffToTransform, __escape_html)
                {
                    var _html = '';
                    for (var _prefix in _stuffToTransform) {
                        for (var _x in _stuffToTransform[_prefix]) {
                            _html += '<div id="evernote_clearly__serialized__' + __escape_html(_prefix) + '__' + __escape_html(_x) + '">';
                            _html +=    __escape_html(_stuffToTransform[_prefix][_x]);
                            _html += '</div>';
                        }
                    }
                    
                    return _html;
                    
                    /*
                        stuffToTransform = {
                            'prefix-id': {
                                'key': 'value'
                            }
                        };
                        
                        result = '<div id="evernote_clearly__serialized__[=prefix]__[=key]">[=value]</div>';
                    */
                };
            
            /* =============== */
            $R.serialize_object_as_custom_html = _serialize_object_as_custom_html;
        })();

    })(window.__readable_by_evernote);


//  ==========================================================================================================================


//  import this
//  ===========
    (function ($R) {
    
        
        //  launch
        //  ======
            $R.launch = function ()
            {
                //  current
                var __doc = gBrowser.contentDocument,
                    __win = __doc.defaultView;
                    
                //  invalid page?
                if (__win && __win.location && __win.location.href && $R.valid_url(__win.location.href)) {}else
                {
                    __win.location = 'chrome://readable-by-evernote/content/blank.html';
                    return;
                }
                    
                //  inject
                $R.inject(__doc);
            };
        

        
        //  dispatch
        //  ========
            $R.__event_dispatch = function (__document, _short_event_name, _arguments)
            {
                //  custom
                switch (_short_event_name)
                {
                    case ('evernote--get-recommendation--successful'):
                        var _iframe = __document.getElementById('evernote_clearly__reformat'),
                            _documentToInjectInto = (_iframe.contentDocument || _iframe.contentWindow.document),
                            _filingRecommendation = $R.$remote.store__id_to_recommendation[_arguments['_page_id']];
        
                        $R.inject_recommendation(_filingRecommendation, _documentToInjectInto, $R.escape_html);
                        break;
            
                    case ('evernote--clip--successful'):
                    case ('evernote--clip-highlights--successful'):
                        var _iframe = __document.getElementById('evernote_clearly__reformat'),
                            _documentToInjectInto = (_iframe.contentDocument || _iframe.contentWindow.document),
                            _filingInfo = $R.$remote.store__id_to_info[_arguments['_page_id']];
        
                        $R.inject_filing_info(_filingInfo, _documentToInjectInto, $R.escape_html);
                        break;
                }
        
                //  dispatch
                $R.custom_events.dispatch($R.custom_events.names_to_objects['to-browser--'+_short_event_name], __document.defaultView);
                
                //  custom action, after
                switch (_short_event_name)
                {
                    case 'evernote--login--show':
                    case 'evernote--login--show--in':
                    case 'evernote--login--show--in-cn':
                    case 'evernote--login--show--cn':
                    case 'evernote--login--show--cn-in':
                    
                        //  localization
                        var _localization = 'in';            
                        switch (_short_event_name)
                        {
                            case 'evernote--login--show--in':    _localization = _short_event_name.substr(-2); break;
                            case 'evernote--login--show--cn':    _localization = _short_event_name.substr(-2); break;
                            case 'evernote--login--show--in-cn': _localization = _short_event_name.substr(-5).replace(/-/g, '_').toLowerCase(); break;
                            case 'evernote--login--show--cn-in': _localization = _short_event_name.substr(-5).replace(/-/g, '_').toLowerCase(); break;
                        }
                    
                        //  set popup
                        $R.$popup = {
                            '_which':    'login',
                            '_tab':      __document,
                            '_details':  { 
                                '_localization': _localization,
                                '_screen':       'credentials'
                            }
                        };
                        
                        //  init
                        try { $R.$nativePopupFrameDocument.defaultView.__readable_by_evernote__secure.init(); } catch (_e) {}
                        
                        //  open popup
                        $R.showPopup();
                        
                        break;
        
                    case 'evernote--login--successful':
                    
                        //  close popup
                        $R.hidePopup();
        
                        //  unset popup
                        $R.$popup = false;
                        
                        break;
                }
            };
        
        
        //  events handler
        //  ==============
            $R.add_events_handler = function (__document)
            {
                //  just once
                if (__document.__readable_event_monitor_attached) { return; }
                __document.__readable_event_monitor_attached = true;
            
                //  dispatcher
                var __event_dispatch = function (_short_event_name, _arguments) { $R.__event_dispatch(__document, _short_event_name, _arguments); };
                
                //  events
                __document.addEventListener('click', function(_event)
                {
                    //  vars
                    var _stop = false,
                        _event_key = $R.custom_events.get_key(_event),
                        _event_name = $R.custom_events.keys_to_names[_event_key];
                        
                    //  invalid
                    if (_event_name) {}else { return; }
                    
                    //  other
                    if (_event_name.indexOf('to-extension--') === 0) {}else { return; }
                    
                    //  vars
                    var _short_event_name = _event_name.substr('to-extension--'.length);
        
                    //  event groups
                    //  ============
                        
                        //  evernote events
                        //  ===============
                            switch (_short_event_name)
                            {
                                case 'evernote--clip':
                                    
                                    (function () {
                                    
                                        //  check login
                                        //  if not logged in, try stored log in 
                                        //      on successfull login, do clip again
                                        //      on failed login, or no stored login, show login form
                                        //    
                                        //  try clip
                                        //      on fail, because of login, try stored login
                                        //          on successfull login, try clip again
                                        //          on failed login, or no stored login, show login form
                                        //  ============================================================
                                        
                                        
                                        //  misc
                                        //  ====    
                                            $R.$remote.refresh_settings();
                                            if ($R.credentials__get_logout_on_next_action()) { $R.$remote.logout(); }
                                            var _storedLogin = $R.credentials__get();
                                    
                                                
                                        //  callbacks
                                        //  =========
                                        
                                            var _clipping_successful = function (_id)
                                            {
                                                __event_dispatch('evernote--clip--successful', { '_page_id': _id });
                                    
                                                var _domain_name = '';
                                    
                                                  var _window = __document.defaultView;
                                                _domain_name = (_window.location && _window.location.href && (_window.location.href.indexOf('/', 8) > -1) ? _window.location.href.substr(0, (_window.location.href.indexOf('/', 8)+1)) : 'blank-domain');
                                            
                                    
                                                var _privilege = ($R.$remote['user__privilege'] ? 'privilege-'+$R.$remote['user__privilege'] : 'blank-privilege');
                                    
                                                $R.session_tracking__track();
                                                $R.analytics__track_event('Clip', _domain_name, _privilege);
                                            };
                                            
                                            var _clipping_failed = function ()
                                            {
                                                __event_dispatch('evernote--clip--failed');
                                            };
                                    
                                            var _request_login = function ()
                                            {
                                                $R.$bootstrap.bootstrap(
                                                    
                                                    //  bootstrap => success
                                                    function ()
                                                    {
                                                        __event_dispatch('evernote--login--show--' + ($R.$bootstrap.profiles_as_string2));
                                                    
                                                        //__event_dispatch2('evernote--login--set--' + ($R.$bootstrap.profiles_as_string2));
                                                        //__event_dispatch2('evernote--login--show--in-frame');
                                                        // __event_dispatch('evernote--login--show');
                                                    },
                                                    
                                                    //  bootstrap => failure
                                                    function () { _clipping_failed(); });
                                            };
                                            
                                            
                                        //  vars
                                        //  ====
                                    
                                             var _iframe = __document.getElementById('evernote_clearly__reformat'),
                                                _doc = (_iframe.contentDocument || _iframe.contentWindow.document),
                                                __id = _doc.getElementById('body').getAttribute('evernote_clearly__page_id'),
                                                __url = __document.defaultView.location.href, 
                                                __title = __document.title, 
                                                __body = $R.get_html_to_clip(_doc);
                                        
                                            
                                        
                                        //  code
                                        //  ====
                                            switch (true)
                                            {
                                                case (!($R.$remote.is__connected)):
                                                case (!($R.$remote.is__loggedIn)):
                                                case (!($R.$remote.is__notExpired())):
                                            
                                                    //  not connected / logged-in
                                                    //      and we know this; so do connect/login
                                            
                                                    //  no stored login
                                                    //  ===============
                                                        if (_storedLogin == false) { _request_login(); return; }
                                            
                                                    //  do stored login
                                                    //  ================
                                                        $R.$remote.loginWithAuthToken(
                                    
                                                            _storedLogin.xAuthToken,
                                    
                                                            //  login => success
                                                            function ()
                                                            {
                                                                $R.$remote.clip(
                                    
                                                                    __id,
                                                                    __url,
                                                                    __title,
                                                                    __body,
                                    
                                                                    //  clip => success
                                                                    function () { _clipping_successful(__id); },
                                    
                                                                    //  clip => failure
                                                                    function (_failReason) { _clipping_failed(); });
                                                            },
                                    
                                                            //  login => failure
                                                            function (_failReason) { _request_login(); });
                                                
                                                    break;
                                                
                                    
                                                default:
                                            
                                                    //  should be both connected and logged in
                                                    //      in case it fails because of login, we try another stored login
                                    
                                                    $R.$remote.clip(
                                                    
                                                        __id,
                                                        __url,
                                                        __title,
                                                        __body,
                                    
                                                        //  clip => success
                                                        function () { _clipping_successful(__id); },
                                    
                                                        //  clip => failuse
                                                        function (_failReason)
                                                        {
                                                            //  failure because of soemthing else
                                                            if (_failReason == 'login') {}else { _clipping_failed(); return; }
                                    
                                                            //  no stored login
                                                            if (_storedLogin == false) { _request_login(); return; }
                                    
                                                            //  try stored login
                                                            $R.$remote.loginWithAuthToken(
                                                            
                                                                _storedLogin.xAuthToken,
                                    
                                                                //  login => success
                                                                function ()
                                                                {
                                                                    $R.$remote.clip(
                                                                    
                                                                        __id,
                                                                        __url,
                                                                        __title,
                                                                        __body,
                                    
                                                                        //  clip => success
                                                                        function () { _clipping_successful(__id); },
                                    
                                                                        //  clip => failure
                                                                        function (_failReason) { _clipping_failed(); });
                                                                },
                                    
                                                                //  login => failure
                                                                function (_failReason) { _request_login(); });
                                                        });
                                    
                                                    break;
                                            }
                                    
                                    })();
                                    
                                    _stop = true;
                                    break;
                        
                                case 'evernote--clip-highlights':
                                    
                                    (function () {
                                    
                                        //  check login
                                        //      if not logged in, fail 
                                        //      on failed login, fail
                                        //    
                                        //  try highlight
                                        //      on fail, fail
                                        //  ============================================================
                                    
                                    
                                        //  misc
                                        //  ====    
                                            $R.$remote.refresh_settings();
                                            if ($R.credentials__get_logout_on_next_action()) { $R.$remote.logout(); }
                                            var _storedLogin = $R.credentials__get();
                                    
                                    
                                        //  callbacks
                                        //  =========
                                                
                                            var _clipping_successful = function (_id)
                                            {
                                                __event_dispatch('evernote--clip-highlights--successful', { '_page_id': _id });
                                                $R.session_tracking__track();
                                            };
                                            
                                            var _clipping_failed = function ()
                                            {
                                                __event_dispatch('evernote--clip-highlights--failed');
                                            };
                                            
                                            var _request_login = function ()
                                            {
                                                $R.$bootstrap.bootstrap(
                                                
                                                    //  bootstrap => success
                                                    function ()
                                                    {
                                                        __event_dispatch('evernote--login--show--' + ($R.$bootstrap.profiles_as_string2));
                                                    
                                                        //__event_dispatch2('evernote--login--set--' + ($R.$bootstrap.profiles_as_string2));
                                                        //__event_dispatch2('evernote--login--show--in-frame');
                                                        // __event_dispatch('evernote--login--show');
                                                    },
                                                    
                                                    //  bootstrap => failure
                                                    function () { _clipping_failed(); });
                                            };
                                    
                                    
                                        //  vars
                                        //  ====
                                    
                                             var _iframe = __document.getElementById('evernote_clearly__reformat'),
                                                _doc = (_iframe.contentDocument || _iframe.contentWindow.document),
                                                __id = _doc.getElementById('body').getAttribute('evernote_clearly__page_id'),
                                                __url = __document.defaultView.location.href, 
                                                __title = __document.title, 
                                                __body = $R.get_html_to_clip(_doc);
                                        
                                        
                                    
                                        //  code
                                        //  ====
                                            switch (true)
                                            {
                                                case (!($R.$remote.is__connected)):
                                                case (!($R.$remote.is__loggedIn)):
                                                case (!($R.$remote.is__notExpired())):
                                    
                                                    //  not connected / logged-in
                                                    //      and we know this; so do connect/login
                                    
                                                    //  no stored login
                                                    //  ===============
                                                        if (_storedLogin == false) { _request_login(); return; }
                                            
                                                    //  do stored login
                                                    //  ================
                                                        $R.$remote.loginWithAuthToken(
                                                        
                                                            _storedLogin.xAuthToken,
                                    
                                                            //  login => success 
                                                            function ()
                                                            {
                                                                $R.$remote.clip(
                                                                
                                                                    __id,
                                                                    __url,
                                                                    __title,
                                                                    __body,
                                    
                                                                    //  clip => success 
                                                                    function () { _clipping_successful(__id); },
                                    
                                                                    //  clip => failure
                                                                    function (_failReason) { _clipping_failed(); });
                                                            },
                                    
                                                            //  login => failure
                                                            function (_failReason) { _request_login(); });
                                                
                                                    break;
                                    
                                                default:
                                    
                                                    //  should be both connected and logged in
                                                    //      in case it fails because of login, we try stored login
                                            
                                                    $R.$remote.clip(
                                                    
                                                        __id,
                                                        __url,
                                                        __title,
                                                        __body,
                                    
                                                        //  clip => success
                                                        function () { _clipping_successful(__id); },
                                    
                                                        //  clip => failure
                                                        function (_failReason)
                                                        {
                                                            //  failure because of soemthing else
                                                            if (_failReason == 'login') {}else { _clipping_failed(); return; }
                                    
                                                            //  no stored login
                                                            if (_storedLogin == false) { _request_login(); return; }
                                    
                                                            //  try stored login
                                                            $R.$remote.loginWithAuthToken(
                                                            
                                                                _storedLogin.xAuthToken,
                                    
                                                                //  login => success
                                                                function ()
                                                                {
                                                                    $R.$remote.clip(
                                                                    
                                                                        __id,
                                                                        __url,
                                                                        __title,
                                                                        __body,
                                    
                                                                        //  clip => success
                                                                        function () { _clipping_successful(message._id); },
                                    
                                                                        //  clip => failure
                                                                        function (_failReason) { _clipping_failed(); });
                                                                },
                                    
                                                                //  login => failure
                                                                function (_failReason) { _request_login(); });
                                                        });
                                                
                                                    break;
                                            }
                                    
                                    })();
                                    
                                    _stop = true;
                                    break;
                        
                        
                                case 'evernote--speech-start':
                                    
                                    (function () {
                                    
                                        //  check login
                                        //      if no login, show speech dialog (with login)
                                        //          if logged in, check premium 
                                        //              if not premium, show speech dialog (with premium)
                                        //      if not logged in but has login, login, check premium
                                        //          if not premium, show speech dialog (with premium)
                                        //      on failed login, show speech dialog (with login)
                                        //  ============================================================
                                        
                                        
                                        //  misc
                                        //  ====    
                                            $R.$remote.refresh_settings();
                                            if ($R.credentials__get_logout_on_next_action()) { $R.$remote.logout(); }
                                            var _storedLogin = $R.credentials__get();
                                    
                                                
                                        //  callbacks
                                        //  =========
                                        
                                            var _request_login = function ()
                                            {
                                                var _need_login = function ()
                                                {
                                                    __event_dispatch('show--dialog-speech--need-login');
                                                
                                                    //__event_dispatch2('evernote--login--set--' + ($R.$bootstrap.profiles_as_string2));
                                                    //__event_dispatch2('evernote--login--show--in-frame');
                                                    // __event_dispatch('show--dialog-speech--need-login');
                                                };
                                                $R.$bootstrap.bootstrap(_need_login, _need_login);
                                            };
                                    
                                            var _speech_or_upgrade = function ()
                                            {
                                                var _check = function () { __event_dispatch((($R.$remote.user__privilege > 1) ? 'evernote--speech--go' : 'show--dialog-speech--need-premium')); };
                                                $R.$remote.updateUserInfo(_check, _check);
                                            };
                                    
                                    
                                        //  run code
                                        //  ========        
                                            switch (true)
                                            {
                                                case (!($R.$remote.is__connected)):
                                                case (!($R.$remote.is__loggedIn)):
                                                case (!($R.$remote.is__notExpired())):
                                            
                                                    //  not connected / logged-in
                                                    //      and we know this; so do connect/login
                                                    
                                                    //  no stored login
                                                    //  ===============
                                                        if (_storedLogin == false) { _request_login(); return; }
                                                    
                                                    //  do stored login
                                                    //  ===============
                                                        $R.$remote.loginWithAuthToken(
                                    
                                                            _storedLogin.xAuthToken,
                                    
                                                            //  login => success
                                                            function () { _speech_or_upgrade(); },
                                    
                                                            //  login => failure
                                                            function (_failReason) { _request_login(); });
                                                
                                                    break;
                                    
                                                default:
                                            
                                                    //    should be both connected and logged in
                                                    //        in case it fails because of login, we try another stored login
                                            
                                                    //  which one?
                                                    _speech_or_upgrade();
                                                    break;
                                            }
                                    
                                    })();
                                    
                                    _stop = true;
                                    break;
                        
                                case 'evernote--speech-show-login':
                                    (function () {
                                        var _f = function () { __event_dispatch('evernote--login--show--' + ($R.$bootstrap.profiles_as_string2)); };
                                        $R.$bootstrap.bootstrap(_f, _f);
                                    })();
                                    _stop = true;
                                    break;
                        
                        
                                case 'evernote--get-recommendation':
                                    
                                    (function () {
                                    
                                        //  check login
                                        //      if not logged in, fail 
                                        //      on failed login, fail
                                        //    
                                        //  try get
                                        //      on fail, fail
                                        //  ============================================================
                                    
                                        
                                        //  misc
                                        //  ====    
                                            $R.$remote.refresh_settings();
                                            if ($R.credentials__get_logout_on_next_action()) { $R.$remote.logout(); }
                                            var _storedLogin = $R.credentials__get();
                                    
                                                
                                        //  callbacks
                                        //  =========
                                    
                                            var _get_successful = function (_id)
                                            {
                                                __event_dispatch('evernote--get-recommendation--successful', { '_page_id': _id });
                                            };
                                            
                                            var _get_failed = function ()
                                            {
                                                __event_dispatch('evernote--get-recommendation--failed');
                                            };
                                    
                                    
                                        //  vars
                                        //  ====
                                    
                                             var _iframe = __document.getElementById('evernote_clearly__reformat'),
                                                _doc = (_iframe.contentDocument || _iframe.contentWindow.document),
                                                __id = _doc.getElementById('body').getAttribute('evernote_clearly__page_id'),
                                                __url = __document.defaultView.location.href, 
                                                __title = __document.title, 
                                                __body = $R.get_html_to_clip(_doc);
                                        
                                    
                                    
                                        //  run code
                                        //  ========        
                                            switch (true)
                                            {
                                                case (!($R.$remote.is__connected)):
                                                case (!($R.$remote.is__loggedIn)):
                                                case (!($R.$remote.is__notExpired())):
                                            
                                                    //  not connected / logged-in
                                                    //      and we know this -- so do connect/login
                                                    
                                                    //  no stored login
                                                    //  ===============
                                                        if (_storedLogin == false) { _get_failed(); return; }
                                            
                                                    //  do stored login
                                                    //  ================
                                                        $R.$remote.loginWithAuthToken(
                                                        
                                                            _storedLogin.xAuthToken,
                                    
                                                            //  login => success
                                                            function ()
                                                            {
                                                                $R.$remote.get_recommendation(
                                                                
                                                                    __id,
                                                                    __url,
                                                                    __body,
                                    
                                                                    //  get => success
                                                                    function () { _get_successful(__id); },
                                    
                                                                    //  get => failure
                                                                    function (_failReason) { _get_failed(); });
                                                            },
                                    
                                                            //  login => failure
                                                            function (_failReason) { _get_failed(); });
                                                
                                                    break;
                                                
                                                default:
                                    
                                                    //    should be both connected and logged in
                                                    //        in case it fails because of login, we try another stored login
                                            
                                                    $R.$remote.get_recommendation(
                                                    
                                                        __id,
                                                        __url,
                                                        __body,
                                    
                                                        //  get => success
                                                        function () { _get_successful(__id); },
                                    
                                                        //  get => failuse
                                                        function (_failReason) { _get_failed(); });
                                                    
                                                    break;
                                            }
                                        
                                    })();
                                    
                                    _stop = true;
                                    break;
                        
                        
                        
                            }
                        
                        
                        //  open events
                        //  ===========
                        
                        
                        var _options_url = 'chrome://readable-by-evernote/content/options.xul';       
                            
                            switch (_short_event_name)
                            {
                                 case 'open--settings':          window.openDialog(_options_url);               _stop = true; break;
                                case 'open--settings--theme':   window.openDialog(_options_url+'#showCustom'); _stop = true; break;
                                case 'open--settings--speech':  window.openDialog(_options_url+'#showSpeech'); _stop = true; break;
                            
                                
                        
                        
                                /* === */
                        
                                case 'open--premium':
                                    
                                        try
                                        {
                                            var _upgrade_url = $R.$bootstrap.remote_domain + 'Checkout.action' + '?origin=' + 'clearly-ff' + '&offer=textToSpeech',
                                                _full_url = $R.$bootstrap.remote_domain + 'SetAuthToken.action?auth=' + encodeURIComponent($R.$remote.user__authToken) + '&targetUrl=' + encodeURIComponent(_upgrade_url);
                                            
                                            $R.open_url_in_new_tab(_full_url);
                                        }
                                        catch (_e) {}
                                    
                                    _stop = true;
                                    break;
                        
                        
                            }
                            
                        
                        //  select events
                        //  =============
                            switch (_short_event_name)
                            {
                                case 'select--theme--theme-1':  $R.saved__select__theme('theme-1'); _stop = true; break;
                                case 'select--theme--theme-2':  $R.saved__select__theme('theme-2'); _stop = true; break;
                                case 'select--theme--theme-3':  $R.saved__select__theme('theme-3'); _stop = true; break;
                                case 'select--theme--custom':   $R.saved__select__theme('custom');  _stop = true; break;
                            
                                case 'select--size--small':     $R.saved__select__size('small');  _stop = true; break;
                                case 'select--size--medium':    $R.saved__select__size('medium'); _stop = true; break;
                                case 'select--size--large':     $R.saved__select__size('large');  _stop = true; break;
                        
                                case 'select--related-notes--just-at-bottom':   $R.saved__select__related_notes('just_at_bottom'); _stop = true; break;
                                case 'select--related-notes--disabled':         $R.saved__select__related_notes('disabled');       _stop = true; break;
                            }
                            
                        
                        //  track events
                        //  ============
                            switch (_short_event_name)
                            {
                                case 'track--view':
                                
                                    var _domain_name = '', _theme_name = '';
                        
                                      var _window = __document.defaultView;
                                    var _frame = __document.getElementById('evernote_clearly__reformat');
                                    var _css = (_frame && _frame.contentDocument && _frame.contentDocument.getElementById ? _frame.contentDocument.getElementById('baseCSS') : false);
                                     _domain_name = (_window.location && _window.location.href && (_window.location.href.indexOf('/', 8) > -1) ? _window.location.href.substr(0, (_window.location.href.indexOf('/', 8)+1)) : 'blank-domain');
                                    _theme_name = (_css && _css.className ? _css.className : 'blank-theme');
                                
                        
                                    $R.session_tracking__track();
                                    $R.analytics__track_event('View', _domain_name, _theme_name);
                                    
                                    _stop = true;
                                    break;
                            
                                case 'track--theme-popup':
                                    $R.session_tracking__track();
                                    $R.analytics__track_event('Theme Popup', 'Theme Popup');
                                    
                                    _stop = true; 
                                    break;
                                    
                                case 'track--settings':
                                    $R.session_tracking__track();
                                    $R.analytics__track_event('Settings Page', 'Settings Page');
                                    
                                    _stop = true;
                                    break;
                                
                                case 'track--speech-start':
                                    $R.session_tracking__track();
                                    $R.analytics__track_event('Speech Function', 'Speech Function');
                                    
                                    _stop = true;
                                    break;
                        
                        
                                case 'track--first-show--check':
                                    switch (true)
                                    {
                                        case (!($R.firstShow)):                                                                      break;
                                        case ($R.firstShow == 'new-features'): __event_dispatch('show--dialog-first--new-features'); break;
                                        case ($R.firstShow == 'all-features'): __event_dispatch('show--dialog-first--all-features'); break;
                                    }
                                    _stop = true;
                                    break;
                                
                                case 'track--first-show--mark':
                        
                                    //  this instance
                                    $R.firstShow = true;
                        
                                    //  persist
                                    $R.storage__set('firstShowIdentifier', $R.first_show_identifier);
                        
                                    _stop = true;
                                    break;
                            }
                            
        
                    //  firefox-only events
                    //  ===================
                        switch (_short_event_name)
                        {
                            /* case 'evernote--login--request-load--from-outside':
        
                                //  vars
                                var _iframe = __document.getElementById('evernote_clearly__reformat'),
                                    _iframe_doc = (_iframe.contentDocument || _iframe.contentWindow.document),
                                    _iframe2 = _iframe_doc.getElementById('login_frame');
        
                                //  definitions
                                var _definitions = {
                                        '_options':      $R.saved__get_options(),
                                        '_vars':         $R.saved__get_vars(),
                                        '_translation':  $R.translation__items
                                    },
                                    _definitions_as_html = '';
                        
                                //  load url into frame -- _iframe2.setAttribute will not work; apparently, doing that --because it loads the iframe asinchronously-- still loads it from within the page's scope; as such, it still fails the security requirements
                                _iframe2.contentWindow.location.href = 'chrome://readable-by-evernote/content/secure_frame/login/page.html';
        
                                //  bind events
                                var _try_add_handler_to_secure_frame = function ()
                                {
                                    //  try again -- if not loaded yet
                                    var __doc = (_iframe2.contentDocument || _iframe2.contentWindow.document);
                                    if (__doc.body.className == 'secureFrame') {}else { window.setTimeout(_try_add_handler_to_secure_frame, 500); return; }
        
                                    //  inject / events
                                    $R.inject2(__doc, _definitions_as_html);
                                    __event_dispatch2 = $R.add_events_handler2(__doc, __event_dispatch);
                                };
                                window.setTimeout(_try_add_handler_to_secure_frame, 500);
        
                                _stop = true;
                                break; */
                        }
                
                        //  stop
                        if (_stop) { _event.stopPropagation(); _event.preventDefault(); }
                }, true);
            };
        
        
        //  dispatcher 2 -- unset
        //  ============
            $R.__event_dispatch2 = function (__document2, _short_event_name2, _arguments2)
            {
                //  custom
                switch (_short_event_name2)
                {
                    case ('evernote--login--request-second-factor'):
                        var _number = __document2.getElementById('evernote_two_factor__message__sms__number');
                        if (_number) { _number.innerHTML = _arguments2['_deliveryHint']; }
                        break;
                }
        
                //  dispatch
                $R.custom_events.dispatch($R.custom_events.names_to_objects['to-browser--'+_short_event_name2], __document2.defaultView);
        
                //  custom action, after
                switch (_short_event_name2)
                {
                    case 'evernote--login--request-second-factor':
            
                        if ($R.$popup && $R.$popup._which && $R.$popup._which == 'login') {
                            $R.$popup._details._screen = 'second-factor';
                            $R.$popup._details._deliveryHint = _arguments2['_deliveryHint'];
                        }
                
                        break;
        
                    case 'evernote--login--set--in':
                    case 'evernote--login--set--in-cn':
                    case 'evernote--login--set--cn':
                    case 'evernote--login--set--cn-in':
        
                        var _localization = '';            
                        switch (_short_event_name2)
                        {
                            case 'evernote--login--set--in':    _localization = _short_event_name2.substr(-2); break;
                            case 'evernote--login--set--cn':    _localization = _short_event_name2.substr(-2); break;
                            case 'evernote--login--set--in-cn': _localization = _short_event_name2.substr(-5).replace(/-/g, '_').toLowerCase(); break;
                            case 'evernote--login--set--cn-in': _localization = _short_event_name2.substr(-5).replace(/-/g, '_').toLowerCase(); break;
                        }
                    
                        //  set?
                        if (_localization > '') {
                            if ($R.$popup && $R.$popup._which && $R.$popup._which == 'login') {
                                $R.$popup._details._localization = _localization;
                            }
                        }
        
                        //  try to change now
                        __document2.getElementById('evernote_login__container_which').className = _localization;
        
                        break;
                }
            };
        
        
        //  events handler 2 -- secure frame
        //  ================
            $R.add_events_handler2 = function (__document2, __event_dispatch)
            {
                //  dispatcher 2 -- dispatcher 1 is passed as an argument
                var __event_dispatch2 = function (_short_event_name2, _arguments2) { $R.__event_dispatch2(__document2, _short_event_name2, _arguments2); };
            
                //  events
                __document2.addEventListener('click', function(_event2)
                {
                    //  vars
                    var _stop2 = false,
                        _event_key2 = $R.custom_events.get_key(_event2),
                        _event_name2 = $R.custom_events.keys_to_names[_event_key2];
                        
                    //  invalid
                    if (_event_name2) {}else { return; }
                    
                    //  other
                    if (_event_name2.indexOf('to-extension--') === 0) {}else { return; }
                    
                    //  vars
                    var _short_event_name2 = _event_name2.substr('to-extension--'.length);
        
                    //  events
                    switch (_short_event_name2)
                    {
                        case 'evernote--login--do':
                            
                            (function () {
                            
                                //  do login
                                //      store login
                                //  ===============
                            
                                
                                //  misc
                                //  ====    
                                    $R.$remote.refresh_settings();
                            
                            
                                //  Long-session Device identification
                                //  ==================================
                                    var __device_id = $R.saved__get_device_id(),
                                        __os = $R.from_user_agent__get_os(window.navigator.userAgent),
                                        __device_description = '';
                            
                            
                            
                            __device_description = 'Mozilla Firefox' + ' (' + __os + ')'; 
                            
                            
                                //  vars
                                //  ====
                            
                                     var _doc = __document2,
                                        _userElement = _doc.getElementById('evernote_login__username'),
                                        _passElement = _doc.getElementById('evernote_login__password'),
                                        __user = (_userElement.value > '' ? _userElement.value : ''),
                                        __pass = (_passElement.value > '' ? _passElement.value : '');
                                
                            
                            
                                //  the actual login
                                //  ================
                                    $R.$remote.loginLongSession(
                                    
                                        __user,
                                        __pass,
                                    
                                        __device_id,
                                        __device_description,
                                
                                        //  login => success
                                        function ()
                                        {
                                            //  save credentials
                                            //  ================
                                                $R.credentials__set({
                                                    'username': $R.$remote.user__username,
                                                    'xAuthToken': $R.$remote.user__authToken
                                                });
                                        
                                            //  raise event
                                            //  ===========
                                                __event_dispatch('evernote--login--successful');
                                        },
                                    
                                        //  login => fail
                                        function (_failReason)
                                        {
                                            switch (_failReason)
                                            {
                                                case 'two-factor':       __event_dispatch2('evernote--login--request-second-factor', { '_deliveryHint': $R.$remote.twoFactor__deliveryHint }); break;
                                                case 'username':         __event_dispatch2('evernote--login--failed--username');         break;
                                                case 'password':         __event_dispatch2('evernote--login--failed--password');         break;
                                                case 'password-reset':   __event_dispatch2('evernote--login--failed--password-reset');   break;
                                                default:                 __event_dispatch2('evernote--login--failed');                   break;
                                            }
                                        });
                            
                            })();
                            
                            _stop = true;
                            break;
        
                        case 'evernote--login--do-second-factor':
                            
                            (function () {
                            
                                //  do login
                                //      store login, if rememberMe
                                //  ==============================
                            
                                
                                //  misc
                                //  ====    
                                    $R.$remote.refresh_settings();
                            
                            
                                //  Long-session Device identification
                                //  ==================================
                                    var __device_id = $R.saved__get_device_id(),
                                        __os = $R.from_user_agent__get_os(window.navigator.userAgent),
                                        __device_description = '';
                            
                            
                            
                            __device_description = 'Mozilla Firefox' + ' (' + __os + ')'; 
                            
                            
                            
                                //  invalid
                                //  =======
                                    if ($R.$remote.twoFactor__authToken) {}else
                                    {
                                        __event_dispatch2('evernote--login--failed');
                                        return;
                                    }
                            
                            
                                //  code
                                //  ====
                            
                                     var _doc = __document2,
                                        _codeElement = _doc.getElementById('evernote_two_factor__code'),
                                        __code = (_codeElement.value > '' ? _codeElement.value : '');
                                
                                
                            
                                //  the actual login
                                //  ================
                                
                                    $R.$remote.loginLongSessionSecondFactor(
                                    
                                        $R.$remote.twoFactor__authToken,
                                        __code,
                                        __device_id,
                                        __device_description,
                                
                                        //  login => success
                                        function ()
                                        {
                                            //  save credentials
                                            $R.credentials__set({
                                                'username': $R.$remote.twoFactor__username,
                                                'xAuthToken': $R.$remote.user__authToken
                                            });
                                        
                                            //  event    
                                            __event_dispatch('evernote--login--successful');
                                        },
                                    
                                        //  login => failure
                                        function (_failReason)
                                        {
                                            switch (_failReason)
                                            {
                                                case 'code':         __event_dispatch2('evernote--login--failed--two-factor--code');     break;
                                                case 'timeout':      __event_dispatch2('evernote--login--failed--two-factor--timeout');  break;
                                                default:             __event_dispatch2('evernote--login--failed');                       break;
                                            }
                                        });
                            
                            })();
                            
                            _stop = true;
                            break;
        
                        case 'evernote--login--switch-to-cn':
                            
                            (function () {
                            
                                //  return
                                if ($R.$bootstrap.profiles_as_string == 'in_cn') {}else { return; }
                            
                                //  set
                                $R.$bootstrap.profiles_as_string = 'cn_in';
                                $R.$bootstrap.server = 'china';
                                $R.$bootstrap.remote_domain = $R.$bootstrap['server_china'];
                                $R.$bootstrap.remote_domain_marketing = false;
                            
                                //  disconnect
                                $R.$remote.disconnect();
                            
                                //  notify
                                __event_dispatch2('evernote--login--set--cn-in');
                            
                            })();
                            
                            _stop = true;
                            break;
        
                        case 'evernote--login--switch-to-in':
                            
                            (function () {
                            
                                //  return
                                if ($R.$bootstrap.profiles_as_string == 'cn_in') {}else { return; }
                                
                                //  set
                                $R.$bootstrap.profiles_as_string = 'in_cn';
                                $R.$bootstrap.server = 'main';
                                $R.$bootstrap.remote_domain = $R.$bootstrap['server_main'];
                                $R.$bootstrap.remote_domain_marketing = false;
                            
                                //  disconenct                    
                                $R.$remote.disconnect();
                            
                                //  notify
                                __event_dispatch2('evernote--login--set--in-cn');
                                
                            })();
                            
                            _stop = true;
                            break;
                
                
                        case 'evernote--login--now-open':
                            __event_dispatch('evernote--login--now-open');
                            _stop = true;
                            break;
                
                
                        case 'open--two-factor-help':
                            
                                var defaultLoginPath = 'https://www.evernote.com/';
                                $R.$bootstrap.bootstrap(
                                
                                    //  bootstrap => success
                                    function ()
                                    {
                                        var _url = '';
                                            _url = (_url > '' ? _url : $R.$bootstrap.remote_domain);
                                            _url = (_url > '' ? _url : defaultLoginPath); 
                                            _url = _url + 'TwoStepHelp.action?auth='+encodeURIComponent($R.$remote.twoFactor__authToken);
                            
                                        $R.open_url_in_new_tab(_url);
                                    },
                                    
                                    //  bootstrap => fail
                                    function ()
                                    {
                                        var _url = defaultLoginPath;
                                            _url = _url + 'TwoStepHelp.action?auth='+encodeURIComponent($R.$remote.twoFactor__authToken);
                            
                                        $R.open_url_in_new_tab(_url);
                                    });
                            
                            _stop = true;
                            break;
                            
                        case 'open--password-reset':
                            
                                var defaultLoginPath = 'https://www.evernote.com/';
                                $R.$bootstrap.bootstrap(
                                
                                    //  bootstrap => success
                                    function ()
                                    {
                                        var _url = '';
                                            _url = (_url > '' ? _url : $R.$bootstrap.remote_domain);
                                            _url = (_url > '' ? _url : defaultLoginPath); 
                                            _url = _url + 'Login.action?targetUrl=%2FChangePassword.action%3Fv1%3Dtrue';
                                            
                                        $R.open_url_in_new_tab(_url);
                                    },
                                    
                                    //  bootstrap => fail
                                    function ()
                                    {
                                        var _url = defaultLoginPath;
                                            _url = _url + 'Login.action?targetUrl=%2FChangePassword.action%3Fv1%3Dtrue';
                                
                                        $R.open_url_in_new_tab(_url);
                                    });
                            
                            _stop = true;
                            break;
                    }
            
                    //  stop
                    if (_stop2) { _event2.stopPropagation(); _event2.preventDefault(); }
                }, true);
            };
        
        
        
        //  inject
        //  ======
            $R.inject = function (__document, __clip_on_launch, __highlight_on_launch, __speech_on_launch)
            {
                //  default
                if (__clip_on_launch) {}else {      __clip_on_launch = false; }
                if (__highlight_on_launch) {}else { __highlight_on_launch = false; }
                if (__speech_on_launch) {}else {    __speech_on_launch = false; }
                
                //  script
                var _postfix = (__clip_on_launch ? '__and_clip' : (__highlight_on_launch ? '__and_highlight' : (__speech_on_launch ? '__and_speech' : ''))),
                    _script = 'chrome://readable-by-evernote/content/js_in_page/launch'+_postfix+'.js';
        
                //  definitions
                var _definitions = {
                        'option':       $R.saved__get_options(),
                        'var':          $R.saved__get_vars(),
                        'translation':  $R.translation__items
                    },
                    _definitions_as_html = $R.serialize_object_as_custom_html(_definitions, $R.escape_html);
        
                //  inject
                $R.inject_launcher(__document, _script, _definitions_as_html);
                
                //  events
                $R.add_events_handler(__document);
            };
        
        
        //  inject 2 -- secure frame
        //  ========
            $R.inject2 = function (__document)
            {
                //  script
                var _script = 'chrome://readable-by-evernote/content/secure_frame/login/in_page.js';
        
                //  definitions
                var _definitions = {
                        'option':       $R.saved__get_options(),
                        'var':          $R.saved__get_vars(),
                        'translation':  $R.translation__items
                    },
                    _definitions_as_html = $R.serialize_object_as_custom_html(_definitions, $R.escape_html);
        
                //  inject
                $R.inject_launcher(__document, _script, _definitions_as_html);
            };
            

        
        //  var
        //  ===
            $R.$nativePopup = false;
            $R.$nativePopupFrame = false;
            $R.$nativePopupFrameDocument = false;
            
        
        //  setup popup
        //  ===========
            $R.setupPopup = function ()
            {
                //  get refs
                $R.$nativePopup = document.getElementById('readable_by_evernote__popup');
                $R.$nativePopupFrame = document.getElementById('readable_by_evernote__popup__frame');
        
                //  navigate frame        
                $R.$nativePopupFrame.setAttribute('src', 'chrome://readable-by-evernote/content/secure_frame/login/page.html');
                
                //  event relay
                var __event_dispatch__to_tab_associated_with_the_popup = function (_short_event_name, _arguments)
                {
                    //  invalid
                    if ($R.$popup && $R.$popup._which && $R.$popup._which == 'login' && $R.$popup._tab) {}else { return; }
                
                    //  dispatch
                    $R.__event_dispatch($R.$popup._tab, _short_event_name, _arguments);
                };
        
                //  bind events
                var _try_add_handler_to_secure_frame = function ()
                {
                    //  try again -- if not loaded yet
                    var __doc = ($R.$nativePopupFrame.contentDocument || $R.$nativePopupFrame.contentWindow.document);
                    if (__doc && __doc.body && __doc.body.className == 'secureFrame') {}else { window.setTimeout(_try_add_handler_to_secure_frame, 500); return; }
        
                    //  inject / events
                    $R.$nativePopupFrameDocument = __doc;
                    $R.inject2(__doc);
                    $R.add_events_handler2(__doc, __event_dispatch__to_tab_associated_with_the_popup);
                };
                window.setTimeout(_try_add_handler_to_secure_frame, 500);
            };
        
        
        //  show
        //  ====
            $R.showPopup = function ()
            {
                $R.$nativePopup.openPopup(document.getElementById('readable_by_evernote__button'), 'bottomcenter topright', 0, 0, false, false);
            };
        
        
        //  hide
        //  ====    
            $R.hidePopup = function ()
            {
                $R.$nativePopup.hidePopup();
            };
        

    })(window.__readable_by_evernote);


//  ==========================================================================================================================


//  run
//  ===
    (function ($R) {

        
        //  hooks
        //  =====
            $R.menu__call =         function () { $R.launch(); };
            $R.context_menu__call = function () { $R.launch(); };
            $R.button__call =       function () { $R.launch(); };
            
        //  keyboard
        //  ========
            window.addEventListener('load', function ()
            {
                //  get keyboard shortcuts
                var _vars = $R.saved__get_vars(),
                    _keyboard_shortcuts = {
                        '_key_activation':  $R.decode(_vars.keys_activation),
                        '_key_clip':        $R.decode(_vars.keys_clip),
                        '_key_highlight':   $R.decode(_vars.keys_highlight),
                        '_key_speech':      $R.decode(_vars.keys_speech)
                    };
        
                //  add hook
                $R.add_keyboard_hook(gBrowser, _keyboard_shortcuts, $R.get_key_combo_from_event, $R.inject);
            }, false);
        
    
        window.addEventListener('load', function ()
        {
            $R.$bootstrap.initialize();        
            $R.$remote.refresh_settings();

            $R.setupPopup();

            $R.first__show();
            $R.first__run();

            $R.assure_defaults();
            
            gBrowser.addEventListener('DOMContentLoaded', function (_event)
            {
                /* valid? */ if (_event.originalTarget && _event.originalTarget.nodeName && _event.originalTarget.nodeName.toLowerCase && _event.originalTarget.nodeName.toLowerCase() == "#document") {}else { return; }
                /* expose */ $R.expose_as_installed(_event.originalTarget.defaultView);
            }, true);

            $R.translation__get_items();
            
        }, false);

    })(window.__readable_by_evernote);
